/*FILE------------------------------------------------------------------------*/
//
//  Comm.cpp
//
//  SUMMARY
//    Common C function source
//
//  WRITER
//    Ryuta Kimura
//
//  HISTORY
//    2005/06/08 New creation
//
/*FILE------------------------------------------------------------------------*/
#include "StdAfx.h"
#include "Comm.h"

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    CheckHex
//
//  PARAMETER
//    int *, CString
//
//  SUMMARY
//    Check Hex value and convert ascii to integer
//
//  EXPLANATION
//    NONE
//
//  RETURN
//    TRUE or FALSE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
int	CheckHex(
			int* pHex,				// [OUT] converted value
			CString strCheckData )	// [IN]  string
{
	char	strBuffer[256];

	sprintf_s( strBuffer, 256, "%s", strCheckData );

	_strlwr_s( strBuffer, 256 );

	size_t nlen = strlen( strBuffer );

	if( !nlen ) return FALSE;

	for( int i = 0 ; i < nlen ; i++ ) {
		char tmp = strBuffer[i];
		if( !( ( tmp >= '0' && tmp <= '9' )
		 || ( tmp >= 'a' && tmp <= 'f' ) ) )
			return FALSE;
	}

	if( pHex )
		sscanf_s( (const char *)strBuffer, "%x", pHex );

	return TRUE;
}	// CheckHex End


/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    GetYUVOffset
//
//  PARAMETER
//	  int pictureType;PictureTypeݒl
//	  int* y0;y0ItZbgli[|C^
//	  int* y1;y1ItZbgli[|C^
//	  int* u;uItZbgli[|C^
//	  int* v;vItZbgli[|C^
//
//  SUMMARY
//    SVOC[Wf[^YUVItZbgl
//
//  EXPLANATION
//    SVOC[Wf[^YUVItZbgl
//
//  RETURN
//    BOOL;TRUE;AFALSE;s
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL GetYUVOffset(int pictureType, int* y0, int* y1, int* u, int* v)
{
	// ItZbgrbgʒu̐ݒ
	int first = 0;
	int second = 1;
	int third = 2;
	int fourth = 3;

	// YUVf[^ʒuItZbg߂
	if( pictureType == UYVY || pictureType == UYVY16) // V1.3.0.0 modify
	//if( pictureType == UYVY)
	{
		*y0 = second;
		*y1 = fourth;
		*v  = third;
		*u  = first;
	}
	else if( pictureType == YUY2 || pictureType == YUY216) // V1.3.0.0 modify
	//else if( pictureType == YUY2)
	{
		*y0 = first;
		*y1 = third;
		*v  = fourth;
		*u  = second;
	}
	else if(pictureType == RAW8)
	{
		*y0 = first;
		*y1 = second;
		*v  = 0;
		*u  = 0;
	}
	else if(pictureType == RAW10 || pictureType == RAW12)
	{
		*y0 = first;
		*y1 = third;
		*v  = 0;
		*u  = 0;
	}

	return TRUE;
}
