/*FILE------------------------------------------------------------------------*/
//
//  Display.cpp
//
//  SUMMARY
//    Frame draw area
//
//  WRITER
//    Ryuta Kimura
//
//  HISTORY
//    2005/05/30 New creation
//
/*FILE------------------------------------------------------------------------*/

#include "stdafx.h"
#include "SVIsam.h"
#include "SVIsamDlg.h"
#include "Display.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDisplay

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    CDisplay
//
//  PARAMETER
//
//  SUMMARY
//    RXgN^
//
//  EXPLANATION
//    RXgN^
//
//  RETURN
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
CDisplay::CDisplay()
{
	m_pbmpFrame = NULL;

	m_lpDrawBuff = NULL;

	m_nFrameW = 0;

	m_nFrameH = 0;

	m_nDisplayW = 0;

	m_nDisplayH = 0;

	m_nImageW = 0;

	m_nImageH = 0;

	m_nImageLen = 0;

	m_nCutX = 0;

	m_nCutY = 0;

	m_dZoomRate = 1.0;

	m_nDisplayMode = FALSE;

	m_nMulti = 0;

	m_nEnable = TRUE;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    ~CDisplay
//
//  PARAMETER
//
//  SUMMARY
//    fXgN^
//
//  EXPLANATION
//    fXgN^
//
//  RETURN
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
CDisplay::~CDisplay()
{
	if(m_pbmpFrame) {
		delete m_pbmpFrame;
		m_pbmpFrame = NULL;
	}

	if(m_lpDrawBuff) {
		delete [] m_lpDrawBuff;
		m_lpDrawBuff = NULL;
	}
}


BEGIN_MESSAGE_MAP(CDisplay, CStatic)
	//{{AFX_MSG_MAP(CDisplay)
	ON_WM_PAINT()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDisplay bZ[W nh

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    AutoLoad
//
//  PARAMETER
//    const UINT nID : ΏۃRg[ID
//    CWnd* pParent : eEBhE
//
//  SUMMARY
//    Attach
//
//  EXPLANATION
//    ΏۃRg[IDhNX
//
//  RETURN
//    Attach
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CDisplay::AutoLoad(const UINT nID, CWnd* pParent)
{
	// _Ci~bNTuNX
	if (!SubclassDlgItem(nID, pParent))
		return FALSE;

	// Rg[̃NCAg̈擾
	CRect DrawArea;
	this->GetClientRect(&DrawArea);

	// Rg[̕yэ擾
	m_nDisplayW = DrawArea.right;
	m_nDisplayH = DrawArea.bottom;

	return TRUE;
}	// AutoLoad End

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    Initialize
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    Initialize
//
//  EXPLANATION
//    NX
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CDisplay::Initialize()
{
	// o
	if(m_pbmpFrame) {
		delete m_pbmpFrame;
		m_pbmpFrame = NULL;
	}

	if(m_lpDrawBuff) {
		delete [] m_lpDrawBuff;
		m_lpDrawBuff = NULL;
	}

	m_nFrameW = 0;

	m_nFrameH = 0;

	m_nImageW = 0;

	m_nImageH = 0;

	m_nImageLen = 0;

	m_nCutX = 0;

	m_nCutY = 0;

	m_dZoomRate = 1.0;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnPaint
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    `揈
//
//  EXPLANATION
//    t[`悷
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CDisplay::OnPaint()
{
	CPaintDC dc(this); // `p̃foCX ReLXg

	// rbg}bvmۂĂmF
	if(!m_pbmpFrame) {
		// mۂĂȂꍇ͕`悵Ȃ

		// wiWYF\
		dc.FillSolidRect(
						0,
						0,
						m_nDisplayW,
						m_nDisplayH,
						DEF_BKCOLOR_MONAREA);
		return;
	}

	CDC dcMem;	// foCXReLXg

	dcMem.CreateCompatibleDC(&dc);

	// obN擾
	CBitmap* pOldBitmap = dcMem.SelectObject(m_pbmpFrame);

	// Lk[hݒ
	::SetStretchBltMode(dc, COLORONCOLOR);

	// ubNrbg]
	dc.BitBlt(
				0,
				0,
				m_nDisplayW,
				m_nDisplayH,
				&dcMem,
				0,
				0,
				SRCCOPY);

	dcMem.SelectObject(pOldBitmap);

	// `pbZ[WƂ CStatic::OnPaint() ĂяoĂ͂܂
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    SetFrame
//
//  PARAMETER
//    pFrame ; RGBϊ̉摜rbg}bvf[^
//
//  SUMMARY
//    `t[ݒ
//
//  EXPLANATION
//    `悷t[ݒ肷
//
//  RETURN
//    ݒ茋
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CDisplay::SetFrame(CFrameData* pFrame)
{
	if(!m_nEnable) {
		return DisableWindow();
	}
	// `GA
	CClientDC dc(this);

	BOOL ret;	// ^[R[h

	CRgn rgn;
	rgn.CreateRectRgn(0, 0, m_nDisplayW, m_nDisplayH);

	// `GAݒ
	dc.SelectClipRgn(&rgn, RGN_AND);

	// obNReLXg擾
	CDC dcMem;
	dcMem.CreateCompatibleDC(&dc);

	if(!m_pbmpFrame) {
		// rbg}bvm
		try {
			m_pbmpFrame = new CBitmap();
			m_pbmpFrame->CreateCompatibleBitmap(&dc, m_nDisplayW, m_nDisplayH);
		}
		catch(CMemoryException* e) {
			// mێs
			e->Delete();
			m_pbmpFrame = NULL;

			return FALSE;
		}
	}

	// obN擾
	CBitmap* pOldBitmap = dcMem.SelectObject(m_pbmpFrame);

	CRgn rgnscope;
	rgnscope.CreateRectRgn(0, 0, m_nDisplayW, m_nDisplayH);
	dcMem.PaintRgn(&rgn);

	// 摜̐Lk[hZbg
	::SetStretchBltMode(dcMem, COLORONCOLOR);

	// F̃uVI
	dcMem.SelectStockObject(NULL_BRUSH);

	// wix
	dcMem.FillSolidRect(
						0,
						0,
						m_nDisplayW,
						m_nDisplayH,
						DEF_BKCOLOR_MONAREA);

	if(m_nFrameW != pFrame->GetWidth() || m_nFrameH != pFrame->GetHeight()) {
		// TCYقȂꍇ͕\obt@Ċmۂ

		m_nFrameW = pFrame->GetWidth();
		m_nFrameH = pFrame->GetHeight();

		int sz = 0;
		int nRGBFrameW = m_nFrameW * 3;
		nRGBFrameW += ((nRGBFrameW % 4) == 0) ? 0 : (4 - (nRGBFrameW % 4));
		sz = nRGBFrameW * m_nFrameH;
		if(sz == 0) return FALSE;

		if(m_lpDrawBuff) {
			delete [] m_lpDrawBuff;
			m_lpDrawBuff = NULL;
		}
		m_lpDrawBuff = new BYTE[sz];
	}

#if 1
	m_lpDrawBuff = pFrame->GetFramePointer();
	m_nImageW = pFrame->GetWidth();
	m_nImageH = pFrame->GetHeight();
	m_nImageLen = m_nImageW * m_nImageH * 3;
	ret = true;
#else
	if(m_dZoomRate < 1) {
		// k
		int nZoomAreaW = (int)((double)m_nDisplayW / m_dZoomRate);
		int nZoomAreaH = (int)((double)m_nDisplayH / m_dZoomRate);
		ret = CutImage(
					m_lpDrawBuff,		// ؂o摜
					&m_nImageW,			// ؂o
					&m_nImageH,			// ؂o
					m_nCutX,			// ؂oʒu(X)
					m_nCutY,			// ؂oʒu(Y)
					nZoomAreaW,			// ؂o
					nZoomAreaH,			// ؂o
					pFrame->GetFramePointer(),		// C[W
					pFrame->GetWidth(),	// C[W
					pFrame->GetHeight(),	// C[W
					1);					// g嗦
	}
	else {
		// g又
		ret = CutImage(
					m_lpDrawBuff,		// ؂o摜
					&m_nImageW,			// ؂o
					&m_nImageH,			// ؂o
					m_nCutX,			// ؂oʒu(X)
					m_nCutY,			// ؂oʒu(Y)
					m_nDisplayW,		// ؂o
					m_nDisplayH,		// ؂o
					pFrame->GetFramePointer(),		// C[W
					pFrame->GetWidth(),	// C[W
					pFrame->GetHeight(),	// C[W
					(int)m_dZoomRate);					// g嗦
	}
	m_nImageLen = m_nImageW * m_nImageH * 3;
#endif

	if(ret) {
		// ؂oyъgk̐
		BITMAPINFO BitmapInfo;
		BitmapInfo.bmiHeader.biSize				= sizeof( BITMAPINFOHEADER );
		BitmapInfo.bmiHeader.biWidth			= m_nImageW;
		BitmapInfo.bmiHeader.biHeight			= m_nImageH;
		BitmapInfo.bmiHeader.biPlanes			= 1;
		BitmapInfo.bmiHeader.biBitCount			= 24;
		BitmapInfo.bmiHeader.biCompression		= BI_RGB;
		BitmapInfo.bmiHeader.biSizeImage		= m_nImageLen;
		BitmapInfo.bmiHeader.biXPelsPerMeter	= 1;
		BitmapInfo.bmiHeader.biYPelsPerMeter	= 1;
		BitmapInfo.bmiHeader.biClrUsed			= 0;
		BitmapInfo.bmiHeader.biClrImportant		= 0;

		// GDIŃfoCXReLXg։摜`
		::StretchDIBits(
					dcMem.GetSafeHdc(),
					0,
					0,
#if 1
					m_nDisplayW,		// ؂o
					m_nDisplayH,		// ؂o
#else
					(int)((double)m_nImageW * m_dZoomRate),
					(int)((double)m_nImageH * m_dZoomRate),
#endif
					0,
					0,
					m_nImageW,
					m_nImageH,
					m_lpDrawBuff,
					&BitmapInfo,
					DIB_RGB_COLORS,
					SRCCOPY );
	}

	// gk[h
	::SetStretchBltMode(dc, COLORONCOLOR);


	// rbg]ŉ摜]
	dc.BitBlt(
			0,
			0,
			m_nDisplayW,
			m_nDisplayH,
			&dcMem,
			0,
			0,
			SRCCOPY);

	dcMem.SelectObject(pOldBitmap);

	return TRUE;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    CutImage
//
//  PARAMETER
//    LPBYTE lpCutImage : ؂o摜
//    int* pnCutSizeW : ؂o
//    int* pnCutSizeH : ؂o
//    int nCutX : ؂oʒu(X)
//    int nCutY : ؂oʒu(Y)
//    int nCutW : ؂o
//    int nCutH : ؂o
//    LPBYTE lpImage : C[W
//    int nImageW : C[W
//    int nImageH : C[W
//    int nZoomRate : g嗦
//
//  SUMMARY
//    摜؂o
//
//  EXPLANATION
//    摜؂o
//
//  RETURN
//    ؂o
//
//  REMARKS
//    g̏ꍇAgɕKvȃf[^𓙔{Ő؂oGDIŊg傷
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CDisplay::CutImage(
						LPBYTE lpCutImage,	// ؂o摜
						int* pnCutSizeW,	// ؂o
						int* pnCutSizeH,	// ؂o
						int nCutX,			// ؂oʒu(X)
						int nCutY,			// ؂oʒu(Y)
						int nCutW,			// ؂o
						int nCutH,			// ؂o
						LPBYTE lpImage,		// C[W
						int nImageW,		// C[W
						int nImageH,		// C[W
						int nZoomRate)		// g嗦
{
	// 摜̐؂os܂

	// ؂oʒu(X)摜mF
	if(nCutX >= nImageW) {
		// ؂oʒu(X)摜Ow
		return FALSE;
	}

	// ؂oʒu(Y)摜mF
	if(nCutY >= nImageH) {
		// ؂oʒu(Y)摜Ow
		return FALSE;
	}

#if 1
	// ؂ovZ
	if((nImageW - nCutX) < nCutW) {
		// w肵؂oƉ摜I[o[
		*pnCutSizeW = nImageW - nCutX;
	}
	else {
		// w肵؂oŉ摜؂o
		*pnCutSizeW = nCutW;
	}
	*pnCutSizeW = nImageW;

	// ؂ovZ
	if((nImageH - nCutY) < nCutH) {
		// w肵؂oƉ摜I[o[
		*pnCutSizeH = nImageH - nCutY;
	}
	else {
		// w肵؂oŉ摜؂o
		*pnCutSizeH = nCutH;
	}
	*pnCutSizeH = nImageH;
#endif

	// gk̃TCY
	*pnCutSizeW = *pnCutSizeW / (nZoomRate / nZoomRate);
	*pnCutSizeH = *pnCutSizeH / (nZoomRate / nZoomRate);

	int y;

	// I_ʒuvZ
	int nEndX, nEndY;
	nEndX = nCutX + *pnCutSizeW;
	nEndY = nCutY + *pnCutSizeH;

	// rbg}bvpfBO
	int nPadding;
	nPadding = (((*pnCutSizeW * 3) % 4) == 0) ? 0 : (4 - ((*pnCutSizeW * 3) % 4));

	// f[^|C^
	LPBYTE lpBuff;
	LPBYTE lpRGB;

	// f[^̐؂o
	int nCutOffset = (*pnCutSizeH - 1) * (*pnCutSizeW * 3 + nPadding);
	int nImageOffset = ((nImageH - nCutY - 1) * nImageW * 3);
	int nImageLineOffset = nCutX * 3;
	for(y = nCutY ; y < nEndY ; y++) {
		lpBuff = lpCutImage + nCutOffset;
		lpRGB = lpImage + nImageOffset + nImageLineOffset;
		memcpy(lpBuff, lpRGB, *pnCutSizeW * 3);
		nCutOffset -= (*pnCutSizeW * 3 + nPadding);
		nImageOffset -= (nImageW * 3);
	}

	return TRUE;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    DisableWindow
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    摜\GA@\OFF
//
//  EXPLANATION
//    摜\GA̋@\OFFɂĂꍇ̏
//
//  RETURN
//    
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CDisplay::DisableWindow()
{
	// `GA
	CPaintDC dc(this);

	// `GA擾
	CRect DrawArea;
	this->GetClientRect(&DrawArea);

	CRgn rgn;
	rgn.CreateRectRgn(0, 0, DrawArea.right, DrawArea.bottom);

	// `GAݒ
	dc.SelectClipRgn(&rgn, RGN_AND);

	// obNReLXg擾
	CDC dcMem;
	dcMem.CreateCompatibleDC(&dc);

	if(!m_pbmpFrame) {
		// rbg}bvm
		try {
			m_pbmpFrame = new CBitmap();
			m_pbmpFrame->CreateCompatibleBitmap(&dc, DrawArea.right, DrawArea.bottom);
		}
		catch(CMemoryException* e) {
			// mێs
			e->Delete();
			m_pbmpFrame = NULL;

			return FALSE;
		}
	}

	// obN擾
	CBitmap* pOldBitmap = dcMem.SelectObject(m_pbmpFrame);

	CRgn rgnscope;
	rgnscope.CreateRectRgn(0, 0, DrawArea.right, DrawArea.bottom);
	dcMem.PaintRgn(&rgn);

	// tHg̐ݒ
	CFont NewFt;
	NewFt.CreateFont(10, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE, SHIFTJIS_CHARSET,
	OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH|FF_DONTCARE, "Arial");
	dcMem.SelectObject(&NewFt);	dcMem.SetTextColor(DEF_FONTCOLOR_MONAREA_NORMAL);	dcMem.SetBkMode(TRANSPARENT);

	// 摜̐Lk[hZbg
	::SetStretchBltMode(dcMem, COLORONCOLOR);

	// F̃uVI
	dcMem.SelectStockObject(NULL_BRUSH);

	// wix
	dcMem.FillSolidRect(
						DrawArea.left,
						DrawArea.top,
						DrawArea.right,
						DrawArea.bottom,
						DEF_BKCOLOR_MONAREA);

	if(m_nDisplayMode) {
		CString csMsg;
		csMsg.Format("No.%d - OFF", m_nMulti + 1);
		dcMem.TextOut(DEF_POS_FONT_MONAREA, DEF_POS_FONT_MONAREA, csMsg, csMsg.GetLength());
	}

	// gk[h
	::SetStretchBltMode( dc, COLORONCOLOR );

	// rbg]ŉ摜]
	dc.BitBlt(
			0,
			0,
			DrawArea.right,
			DrawArea.bottom,
			&dcMem,
			0,
			0,
			SRCCOPY);

	dcMem.SelectObject(pOldBitmap);

	Invalidate(FALSE);

	return TRUE;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnSize
//
//  PARAMETER
//    UINT nType : TCYύX̃^Cv
//    int cx : 
//    int cy : 
//
//  SUMMARY
//    摜\GATCYύX
//
//  EXPLANATION
//    摜\GÃTCYύXۂ̏
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CDisplay::OnSize(UINT nType, int cx, int cy)
{
	CStatic::OnSize(nType, cx, cy);

	// Rg[̕yэ擾
	m_nDisplayW = cx;
	m_nDisplayH = cy;
}
