/*FILE------------------------------------------------------------------------*/
//
//  Display.h : wb_[ t@C
//
//  SUMMARY
//    Frame draw area
//
//  WRITER
//    Ryuta Kimura
//
//  HISTORY
//    2005/05/30 New creation
//
/*FILE------------------------------------------------------------------------*/
#if !defined(AFX_DISPLAY_H__8E4DB520_E693_4521_B28F_009FFC159049__INCLUDED_)
#define AFX_DISPLAY_H__8E4DB520_E693_4521_B28F_009FFC159049__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FrameData.h"
//#include "SVIAnalyze.h"
/*CLASS-----------------------------------------------------------------------*/
//  NAME
//    CDisplay
//
//  SUMMARY
//    Frame draw area class.
//
//  EXPLANATION
//    NONE
//
//  REMARKS
//    NONE
//
/*CLASS-----------------------------------------------------------------------*/
class CDisplay : public CStatic
{
// RXgNV
public:
	CDisplay();

// Agr[g
public:

// Iy[V
public:

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CDisplay)
	//}}AFX_VIRTUAL

// Cve[V
public:
	virtual ~CDisplay();

	// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(CDisplay)
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

public:
	// hNX
	BOOL AutoLoad(const UINT nID, CWnd* pParent);

	// t[ݒ
	BOOL SetFrame(CFrameData* pFrame);

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    SetZoom
	//
	//  PARAMETER
	//    dZoom    gk
	//
	//  SUMMARY
	//    gkݒ
	//
	//  EXPLANATION
	//    gkZbg
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void SetZoom(double dZoom) { m_dZoomRate = dZoom; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    GetZoom
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    gk擾
	//
	//  EXPLANATION
	//    gk擾
	//
	//  RETURN
	//    gk
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline double GetZoom() { return m_dZoomRate; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    ReDraw
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    ĕ`w
	//
	//  EXPLANATION
	//    Windows ɉʂ̍ĕ`w肵܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void ReDraw() { Invalidate(FALSE); };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    SetCutSize
	//
	//  PARAMETER
	//    CutPos    ؂oʒu
	//
	//  SUMMARY
	//    ؂oʒuw
	//
	//  EXPLANATION
	//    摜̐؂oʒuw肵܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void SetCutPos(CPoint CutPos) { m_nCutX = CutPos.x; m_nCutY = CutPos.y; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    SetCutSize
	//
	//  PARAMETER
	//    nCutX    ؂oʒu x W
	//    nCutY    ؂oʒu y W
	//
	//  SUMMARY
	//    ؂oʒuw
	//
	//  EXPLANATION
	//    摜̐؂oʒuw肵܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void SetCutPos(int nCutX, int nCutY) { m_nCutX = nCutX; m_nCutY = nCutY; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    SetCutX
	//
	//  PARAMETER
	//    nCutX    ؂oʒu x W
	//
	//  SUMMARY
	//   ؂oʒu X Wݒ
	//
	//  EXPLANATION
	//    摜̐؂oʒu x Ww肵܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void SetCutX(int nCutX) { m_nCutX = nCutX; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    SetCutY
	//
	//  PARAMETER
	//    nCutY    ؂oʒu y W
	//
	//  SUMMARY
	//   ؂oʒu Y Wݒ
	//
	//  EXPLANATION
	//    摜̐؂oʒu y Ww肵܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void SetCutY(int nCutY) { m_nCutY = nCutY; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    GetDisplayW
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    摜\GA擾
	//
	//  EXPLANATION
	//    摜\GA擾܂
	//
	//  RETURN
	//    摜\GA
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline int GetDisplayW() { return m_nDisplayW; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    GetDisplayH
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    摜\GA擾
	//
	//  EXPLANATION
	//    摜\GA擾܂
	//
	//  RETURN
	//    摜\GA
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline int GetDisplayH() { return m_nDisplayH; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    SetMultiMode
	//
	//  PARAMETER
	//    nMultiNo    }`쎞̃GAԍ
	//
	//  SUMMARY
	//    }`[h̐ݒ
	//
	//  EXPLANATION
	//    }`[h̐ݒs܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void SetMultiMode(int nMultiNo) { m_nMulti = nMultiNo; m_nDisplayMode = TRUE; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    SetEnable
	//
	//  PARAMETER
	//    bEnable    GA`L/
	//
	//  SUMMARY
	//    GA`L/ݒ
	//
	//  EXPLANATION
	//    GA`̗L܂͖ݒ肵܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void SetEnable(BOOL bEnable) { m_nEnable = bEnable; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    GetEnable
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    GA`L/擾
	//
	//  EXPLANATION
	//    GA`悪L擾܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline int GetEnable() { return m_nEnable; };

	BOOL DisableWindow();

	void Initialize();

private:
	// 摜؂o
	BOOL CutImage(
						LPBYTE lpCutImage,	// ؂o摜
						int* pnCutSizeW,	// ؂o
						int* pnCutSizeH,	// ؂o
						int nCutX,			// ؂oʒu(X)
						int nCutY,			// ؂oʒu(Y)
						int nCutW,			// ؂o
						int nCutH,			// ؂o
						LPBYTE lpImage,		// C[W
						int nImageW,		// C[W
						int nImageH,		// C[W
						int nZoomRate);		// g嗦


	CBitmap* m_pbmpFrame;				// t[`rbg}bvNX|C
										// ^

	LPBYTE m_lpDrawBuff;				// RGB؂ot[f[^

	int m_nDisplayW;					// 摜\GA

	int m_nDisplayH;					// 摜\GA

	int m_nImageW;						// ݕ\Ă摜i؂oj

	int m_nImageH;						// 摜i؂oj

	int m_nImageLen;					// 摜f[^TCY

	int m_nFrameW;						// ݕ\Ă摜t[

	int m_nFrameH;						// ݕ\Ă摜t[

	int m_nCutX;						// t[̐؂oʒui}`
										// 쎞wAVO0j

	int m_nCutY;						// t[̐؂oʒui}`
										// 쎞wAVO0j

	int m_nDisplayMode;					// VOA}`

	int m_nMulti;						// }`쎞̃GAԍ

	BOOL m_nEnable;						// GA`L/

	double m_dZoomRate;					// gk
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_DISPLAY_H__8E4DB520_E693_4521_B28F_009FFC159049__INCLUDED_)
