/*FILE------------------------------------------------------------------------*/
//
//  DoubleBuffer.cpp
//
//  SUMMARY
//    Monitoring Double Buffer
//
//  WRITER
//    Ryuta Kimura
//
//  HISTORY
//    2005/05/30 New creation
//
/*FILE------------------------------------------------------------------------*/
#include "StdAfx.h"
#include "DoubleBuffer.h"

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    CDoubleBuffer
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    RXgN^
//
//  EXPLANATION
//    NONE
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
CDoubleBuffer::CDoubleBuffer() 
{
	// obt@m
	m_pDoubleFrame = new CFrameData[DOUBLE_BUFFER];

	// obt@
	Release();
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    ~CDoubleBuffer
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    fXgN^
//
//  EXPLANATION
//    NONE
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
CDoubleBuffer::~CDoubleBuffer() 
{
	// obt@
	Release();

	delete [] m_pDoubleFrame;

}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    Release
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    t[
//
//  EXPLANATION
//    NXŊmۂĂׂĉE
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CDoubleBuffer::Release() 
{
	// _uobt@ŊmۂĂt[obt@
	m_nView = 0;
	for(int i = 0 ; i < DOUBLE_BUFFER ; i++) {
		m_pDoubleFrame[i].Release();
	}
}


/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    GetWriteFrame
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    ݗpobt@擾
//
//  EXPLANATION
//    _uobt@̂obt@΂̃|C^Ԃ
//
//  RETURN
//    󂫃obt@CFrameDataNX|C^
//
//  REMARKS
//    󂫃obt@ȂꍇNULLԂ܂
//
/*MFUNC-----------------------------------------------------------------------*/
CFrameData* CDoubleBuffer::GetWriteFrame() 
{
	// _uobt@̂󂫃obt@擾

	CFrameData* pFrame = NULL;	// t[|C^

	// 󂫃obt@mF[v
	for(int i = m_nView ; i < DOUBLE_BUFFER ; i++) {

		// obt@bNĂ邩mF
		if(!(m_pDoubleFrame[i].IsLock())) {
			// bNĂȂꍇA݃bNs
			m_pDoubleFrame[i].LockW();
			pFrame = (m_pDoubleFrame + i);
TRACE("FRAME-1 %d %d\n", i, m_nView);
			return pFrame;
		}
	}

	int ii;
	for(ii = 0 ; ii < m_nView ; ii++) {

		// obt@bNĂ邩mF
		if(!(m_pDoubleFrame[ii].IsLock())) {
			// bNĂȂꍇA݃bNs
			m_pDoubleFrame[ii].LockW();
			pFrame = (m_pDoubleFrame + ii);
TRACE("FRAME-2 %d %d\n", ii, m_nView);
			return pFrame;
		}
	}

TRACE("FRAME NULL %d %d\n", ii, m_nView);
	// t[obt@Ԃ
	return pFrame;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    GetReadFrame
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    j^Ot[i[obt@擾
//
//  EXPLANATION
//    j^Ot[i[Ăobt@Ԃ܂
//
//  RETURN
//    j^Ot[i[obt@CFrameDataNX|C^
//
//  REMARKS
//    j^Ot[i[ꂽobt@ȂꍇNULLԂ܂
//
/*MFUNC-----------------------------------------------------------------------*/
CFrameData* CDoubleBuffer::GetReadFrame() 
{
	// t[i[Ăobt@Ԃ

	CFrameData* pFrame = NULL;	// t[|C^

	// t[i[Ăobt@mF
	if(m_pDoubleFrame[m_nView].IsLockR()) {
		// ΏۂƂȂobt@ɓǂݍ݃bNĂꍇA
		// t[obt@|C^擾
		pFrame = (m_pDoubleFrame + m_nView);

		// Ώۃobt@JE^1
		m_nView++;
		if(m_nView >= DOUBLE_BUFFER) {
			// Ώۃobt@JE^_uobt@ȏ
			// w肵ꍇ́Aŏ̃obt@֖߂
			m_nView = 0;
		}
	}

	// t[obt@Ԃ
	return pFrame;
}
