/*FILE------------------------------------------------------------------------*/
//
//  FrameData.cpp
//
//  SUMMARY
//    SVI SDK Frame data
//
//  WRITER
//    Ryuta Kimura
//
//  HISTORY
//    2005/05/30 New creation
//
/*FILE------------------------------------------------------------------------*/

#include "stdafx.h"
#include "FrameData.h"

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    CFrameData
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    RXgN^
//
//  EXPLANATION
//    CFrameDataNXRXgN^
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
CFrameData::CFrameData()
{
	// oϐ

	// vCx[gq[vnh쐬
	m_hFrame = HeapCreate(0, 0x200000, 0);	// g\Al 2MB

	// t[obt@
	m_lpFrameBuffer = NULL;

	// t[obt@TCY
	m_nFrameBufferSize = 0;

	// t[XTCY
	m_nWidth = 0;

	// t[YTCY
	m_nHeight = 0;

	// j^Owb_
	memset(&m_MonHeader, 0, sizeof(MON_HEADER));

	// t[f[^AbN
	UnLockR();
	UnLockW();
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    ~CFrameData
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    fXgN^
//
//  EXPLANATION
//    CFrameDataNXfgN^
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
CFrameData::~CFrameData()
{
	// oϐ
	Release();

	// vCx[gq[vnh
	if(m_hFrame)
	{
		HeapDestroy(m_hFrame);
		m_hFrame = NULL;
	}
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    Release
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    NX
//
//  EXPLANATION
//    NXŊmہEێĂ邷ׂĂ̏
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CFrameData::Release()
{
	// oϐ

	// t[obt@
	if(m_lpFrameBuffer != NULL) {
		HeapFree(m_hFrame, 0, m_lpFrameBuffer);
		m_lpFrameBuffer = NULL;
	}

//	// t[obt@nh
//	if(m_hFrame != NULL) {
//		GlobalFree(m_hFrame);
//		m_hFrame = NULL;
//	}

	// t[obt@TCY
	m_nFrameBufferSize = 0;

	// t[XTCY
	m_nWidth = 0;

	// t[YTCY
	m_nHeight = 0;

	// j^Owb_
	memset(&m_MonHeader, 0, sizeof(MON_HEADER));

	// AbN
	m_bLock = 0;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    ReservBuffer
//
//  PARAMETER
//    int nBufferSize : mۂobt@TCY
//
//  SUMMARY
//    t[obt@m
//
//  EXPLANATION
//    w肳ꂽTCỸt[obt@mۂ܂
//
//  RETURN
//    mی
//
//  REMARKS
//    ׂĂ̏͏܂Bobt@݂̂̍Ċmۂsꍇ[ReReserv]֐gp܂B
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CFrameData::ReservBuffer(int nBufferSize)
{
	// 
	Release();

	// obt@nh擾
//	m_hFrame = GlobalAlloc(GHND,  nBufferSize);
//	if(m_hFrame == NULL) {
//		return FALSE;
//	}

	// obt@擾
	m_lpFrameBuffer = HeapAlloc(m_hFrame, HEAP_ZERO_MEMORY, nBufferSize);
	if(m_lpFrameBuffer == NULL) {
		// t[obt@nh
//		if(m_hFrame != NULL) {
//			GlobalFree(m_hFrame);
//			m_hFrame = NULL;
//		}
		return FALSE;
	}

	m_nFrameBufferSize = nBufferSize;

	return TRUE;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    ReReserv
//
//  PARAMETER
//    int nBufferSize : mۂobt@TCY
//
//  SUMMARY
//    t[obt@Ċm
//
//  EXPLANATION
//    w肳ꂽTCỸt[obt@mۂ܂
//
//  RETURN
//    mی
//
//  REMARKS
//    obt@̍Ċmۂ݂̂s܂BxׂĂ̏ĐVɃobt@
//    mۂꍇ[ReservBuffer]gp܂B
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CFrameData::ReReserv(int nBufferSize)
{
	// t[obt@
	if(m_lpFrameBuffer != NULL) {
		HeapFree(m_hFrame, 0, m_lpFrameBuffer);
		m_lpFrameBuffer = NULL;
	}

	// t[obt@nh
//	if(m_hFrame != NULL) {
//		GlobalFree(m_hFrame);
//		m_hFrame = NULL;
//	}

	// t[obt@̊m
	// obt@nh擾
//	m_hFrame = GlobalAlloc(GHND, nBufferSize);
//	if(m_hFrame == NULL) {
//		return FALSE;
//	}

	// obt@擾
	m_lpFrameBuffer = HeapAlloc(m_hFrame, HEAP_ZERO_MEMORY, nBufferSize);
	if(m_lpFrameBuffer == NULL) {
		// t[obt@nh
//		if(m_hFrame != NULL) {
//			GlobalFree(m_hFrame);
//			m_hFrame = NULL;
//		}
		return FALSE;
	}

	// obt@TCYێ
	m_nFrameBufferSize = nBufferSize;

	return TRUE;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    CopyBuffer
//
//  PARAMETER
//    LPBYTE lpCopyBuffer : Rs[obt@
//    int nBufferSize : lpCopyBuffer̃TCY
//
//  SUMMARY
//    obt@Rs[
//
//  EXPLANATION
//    mۂĂobt@f[^w肳ꂽobt@փRs[܂
//
//  RETURN
//    Rs[TCY
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
int CFrameData::CopyBuffer(LPBYTE lpCopyBuffer, int nBufferSize)
{
	if(m_lpFrameBuffer == NULL) return 0;

	int nCopySize = (m_nFrameBufferSize > nBufferSize)?nBufferSize:m_nFrameBufferSize;

	memcpy(m_lpFrameBuffer, lpCopyBuffer, nCopySize);

	return nCopySize;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    SetFrameSize
//
//  PARAMETER
//    CSize FrameSize : t[TCY
//
//  SUMMARY
//    t[TCYݒ
//
//  EXPLANATION
//    t[̃TCYݒ肵܂
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CFrameData::SetFrameSize(CSize FrameSize)
{
	m_nWidth = FrameSize.cx;
	m_nHeight = FrameSize.cy;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    SetFrameSize
//
//  PARAMETER
//    int nW : t[
//    int nH : t[
//
//  SUMMARY
//    t[TCYݒ
//
//  EXPLANATION
//    t[̃TCYݒ肵܂
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CFrameData::SetFrameSize(int nW, int nH)
{
	m_nWidth = nW;
	m_nHeight = nH;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    GetFrameSize
//
//  PARAMETER
//    CSize* pFrameSize : t[TCY擾|C^
//
//  SUMMARY
//    t[TCY擾
//
//  EXPLANATION
//    t[̃TCY擾܂
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CFrameData::GetFrameSize(CSize* pFrameSize)
{
	pFrameSize->cx = m_nWidth;
	pFrameSize->cy = m_nHeight;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    GetFrameSize
//
//  PARAMETER
//    int* pnW : t[擾|C^
//    int* pnH : t[擾|C^
//
//  SUMMARY
//    t[TCY擾
//
//  EXPLANATION
//    t[̃TCY擾܂
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CFrameData::GetFrameSize(int* pnW, int* pnH)
{
	*pnW = m_nWidth;
	*pnH = m_nHeight;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    SetMonHeader
//
//  PARAMETER
//    MON_HEADER MonHeader : j^Owb_
//
//  SUMMARY
//    j^Owb_ݒ
//
//  EXPLANATION
//    j^Owb_ݒ肵܂
//
//  RETURN
//    NONE
//
//  REMARKS
//    j^Owb_̐ݒƓɃt[TCYύX܂B
//
/*MFUNC-----------------------------------------------------------------------*/
void CFrameData::SetMonHeader(MON_HEADER MonHeader)
{
	m_MonHeader = MonHeader;
	m_nWidth = MonHeader.ulMonSizeW;
	m_nHeight = MonHeader.ulMonSizeH;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    SetFrameData
//
//  PARAMETER
//    CFrameData* pFrame : t[f[^|C^
//
//  SUMMARY
//    t[f[^ݒ
//
//  EXPLANATION
//    w肳ꂽCFrameDatag֐ݒ肵܂
//
//  RETURN
//    ݒ茋
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CFrameData::SetFrameData(CFrameData* pFrame)
{
	if(ReservBuffer(pFrame->GetBufferSize()) == TRUE) {
#if 1	// 2010.03.11 2.2.0.0 QƌƃRs[悪t̂C
		CopyBuffer(pFrame->GetFramePointer(), m_nFrameBufferSize);
#endif
		pFrame->GetFrameSize(&m_nWidth, &m_nHeight);
		m_MonHeader = pFrame->GetMonHeader();
		return TRUE;
	}

	return FALSE;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    GetFrameData
//
//  PARAMETER
//    CFrameData* pFrame : t[f[^|C^
//
//  SUMMARY
//    t[f[^擾
//
//  EXPLANATION
//    w肳ꂽCFrameDataɎgRs[܂
//
//  RETURN
//    擾
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CFrameData::GetFrameData(CFrameData* pFrame)
{
	return pFrame->SetFrameData(this);
}
