/*FILE------------------------------------------------------------------------*/
//
//
//  SUMMARY
//    SVI SDK Frame data
//
//  WRITER
//    Ryuta Kimura
//
//  HISTORY
//    2005/05/30 New creation
//
/*FILE------------------------------------------------------------------------*/

#ifndef _FRAME_DATA_H
#define _FRAME_DATA_H

#include "SVI3Ddef.h"

#define LOCK_READ	0x01	// ǂݍ݁ij^Ot[擾jbN
#define LOCK_WRITT	0x02	// ݁ij^Ot[ݒjbN

/*CLASS-----------------------------------------------------------------------*/
//  NAME
//    CFrameData
//
//  SUMMARY
//    SVI SDK Frame data class.
//
//  EXPLANATION
//    NONE
//
//  REMARKS
//    NONE
//
/*CLASS-----------------------------------------------------------------------*/
class CFrameData
{
public:
	// RXgN^
	CFrameData();

	// fXgN^
	virtual ~CFrameData();

public: // Iy[V
	// [X
	void Release();

	// obt@̊m
	BOOL ReservBuffer(int nBufferSize);

	// obt@݂̂̍Ċm
	BOOL ReReserv(int nBufferSize);

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    GetFramePointer
	//  PARAMETER
	//
	//  SUMMARY
	//    obt@|C^̎擾
	//
	//  EXPLANATION
	//    t[obt@̃|C^擾܂
	//
	//  RETURN
	//    t[obt@̃|C^
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline LPBYTE GetFramePointer() { return (LPBYTE)m_lpFrameBuffer; };

	// obt@Rs[
	int CopyBuffer(LPBYTE lpCopyBuffer, int nBufferSize);

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    GetBufferSize
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    obt@TCY擾
	//
	//  EXPLANATION
	//    t[obt@̃TCY擾܂
	//
	//  RETURN
	//    t[obt@̃TCY
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline int GetBufferSize() { return m_nFrameBufferSize; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    SetFrameLen
	//
	//  PARAMETER
	//    nFrameSize  t[TCY
	//
	//  SUMMARY
	//    t[TCYݒ
	//
	//  EXPLANATION
	//    t[TCYݒ肵܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void SetFrameLen(int nFrameSize) { m_nFrameSize = nFrameSize; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    t[TCY擾
	//
	//  EXPLANATION
	//    t[TCY擾܂
	//
	//  RETURN
	//    t[TCY
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline int GetFrameLen() { return m_nFrameSize; };

	// t[cTCYݒ
	void SetFrameSize(CSize FrameSize);

	// t[cTCYݒ
	void SetFrameSize(int nW, int nH);

	// t[cTCY擾
	void GetFrameSize(CSize* pFrameSize);

	// t[cTCY擾
	void GetFrameSize(int* pnW, int* pnH);

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    GetHeight
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    t[cTCY
	//
	//  EXPLANATION
	//    t[cTCY擾܂
	//
	//  RETURN
	//    t[cTCY
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline int GetHeight() { return m_nHeight; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    GetWidth
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    t[TCY擾
	//
	//  EXPLANATION
	//    t[̉TCY擾܂
	//
	//  RETURN
	//    t[TCY
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline int GetWidth() { return m_nWidth; };

	// j^Owb_ݒ
	void SetMonHeader(MON_HEADER MonHeader);

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    GetMonHeader
	//  PARAMETER
	//
	//  SUMMARY
	//    j^Owb_擾
	//
	//  EXPLANATION
	//    j^Owb_擾܂
	//
	//  RETURN
	//    j^Owb_
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline MON_HEADER GetMonHeader() { return m_MonHeader; };

	// t[f[^ݒ
	BOOL SetFrameData(CFrameData* Frame);

	// t[f[^擾
	BOOL GetFrameData(CFrameData* pFrame);

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    LockW
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    t[f[^݃bNݒ
	//
	//  EXPLANATION
	//    t[f[^ւ̏݃bNtOݒ肵܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void LockW() { m_bLock |= LOCK_WRITT; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    UnLockW
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    t[f[^݃bN
	//
	//  EXPLANATION
	//    t[f[^ւ̏݃bN܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void UnLockW() { m_bLock &= ~LOCK_WRITT; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    IsLockW
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    t[f[^݃bNԎ擾
	//
	//  EXPLANATION
	//    t[f[^ւ̏݃bNԂ擾܂
	//
	//  RETURN
	//    TRUE:bN  FALSE:bN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline BOOL IsLockW() { return m_bLock&LOCK_WRITT; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    IsLockR
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    t[f[^ǂݍ݃bNݒ
	//
	//  EXPLANATION
	//    t[f[^̓ǂݍ݃bNݒ肵܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void LockR() { m_bLock |= LOCK_READ; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    UnLockR
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    t[f[^ǂݍ݃bN
	//
	//  EXPLANATION
	//    t[f[^̓ǂݍ݃bN܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void UnLockR() { m_bLock &= ~LOCK_READ; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    IsLockR
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    t[f[^ǂݍ݃bNԎ擾
	//
	//  EXPLANATION
	//    t[f[^ǂݍ݃bN̏Ԃ擾܂
	//
	//  RETURN
	//    TRUE:bN  FALSE:bN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline BOOL IsLockR() { return m_bLock&LOCK_READ; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//
	//  PARAMETER
	//
	//  SUMMARY
	//   t[f[^bNԎ擾
	//
	//  EXPLANATION
	//   t[f[^̃bNԂ擾܂
	//
	//  RETURN
	//    TRUE:ǂ炩̃bNĂ  FALSE:ǂ̃bNĂȂ
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline BOOL IsLock() { return m_bLock; };

private:

	HANDLE m_hFrame;					// t[obt@nh

	LPVOID m_lpFrameBuffer;				// t[obt@

	int	m_nFrameBufferSize;				// t[obt@TCY

	int m_nFrameSize;					// t[TCY

	int m_nWidth;						// t[XTCY

	int m_nHeight;						// t[YTCY

	MON_HEADER m_MonHeader;				// j^Owb_

	BOOL m_bLock;						// t[f[^̃bNi_uobt
										// @gpj
};

#endif
