/*FILE------------------------------------------------------------------------*/
//
//
//  SUMMARY
//    INI File Access Interface
//
//  WRITER
//    Ryuta Kimura
//
//  HISTORY
//        2005/05/30 New creation
//
/*FILE------------------------------------------------------------------------*/
#ifndef _INI_CONTROL_H
#define _INI_CONTROL_H

/*CLASS-----------------------------------------------------------------------*/
//  NAME
//    CIniControl
//
//  SUMMARY
//    INIt@CANZXNX
//
//  EXPLANATION
//    INIt@Cւ̓ǂݏ񋟂NX
//
//  REMARKS
//        NONE
//
/*CLASS-----------------------------------------------------------------------*/
class CIniControl
{
public:
	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    CIniControl
	//
	//  PARAMETER
	//    csAppName     Init@CAPP
	//    csIniFilePath Init@CpX
	//
	//  SUMMARY
	//    NXRXgN^
	//
	//  EXPLANATION
	//    NXRXgN^
	//
	//  RETURN
	//    NONE
	//
	//  REMARKS
	//    NONE
	//
	/*MFUNC-----------------------------------------------------------------------*/
	CIniControl(
		CString csAppName,			// Init@CAPP
		CString csIniFilePath)		// Init@CpX
	{
		m_csAppName		= csAppName;
		m_csIniFilePath	= csIniFilePath;
	};

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    WriteInt
	//
	//  PARAMETER
	//    csKeyName L[
	//    nValue    Zbgl
	//
	//  SUMMARY
	//    intinit@Cɏ݂܂
	//
	//  EXPLANATION
	//    intinit@Cɏ݂܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void WriteInt(CString csKeyName,	// L[
				int nValue)					// Zbgl
	{
		char pcWork[128];
		_itoa_s(nValue,pcWork,128,10);
		WritePrivateProfileString(m_csAppName,csKeyName,pcWork,m_csIniFilePath);
	};

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    WriteFloat
	//
	//  PARAMETER
	//    csKeyName L[
	//    fValue    Zbgl
	//
	//  SUMMARY
	//    floatinit@Cɏ݂܂
	//
	//  EXPLANATION
	//    floatinit@Cɏ݂܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void WriteFloat(CString csKeyName,	// L[
				float fValue)					// Zbgl
	{
		char work[128];
		_gcvt_s(work,128,fValue,8);
		WritePrivateProfileString(m_csAppName,csKeyName,work,m_csIniFilePath);
	};

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    WriteDouble
	//
	//  PARAMETER
	//    csKeyName L[
	//    dValue    Zbgl
	//
	//  SUMMARY
	//    doubleinit@Cɏ݂܂
	//
	//  EXPLANATION
	//    doubleinit@Cɏ݂܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void WriteDouble(CString csKeyName,	// L[
				double dValue)					// Zbgl
	{
		char work[128];
		_gcvt_s(work,128,dValue,8);
		WritePrivateProfileString(m_csAppName,csKeyName,work,m_csIniFilePath);
	};

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    WriteBool
	//
	//  PARAMETER
	//    csKeyName L[
	//    bValue    Zbgl
	//
	//  SUMMARY
	//    boolinit@Cɏ݂܂
	//
	//  EXPLANATION
	//    boolinit@Cɏ݂܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void WriteBool(CString csKeyName,	// L[
				bool bValue)					// Zbgl
	{
		WritePrivateProfileString(m_csAppName,csKeyName,(bValue ? "true" : "false"),m_csIniFilePath);
	};

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    WriteString
	//
	//  PARAMETER
	//    csKeyName L[
	//    pcValue   Zbgl
	//
	//  SUMMARY
	//    init@Cɏ݂܂
	//
	//  EXPLANATION
	//    init@Cɏ݂܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void WriteString(CString csKeyName,	// L[
				char* pcValue)					// Zbgl
	{
		WritePrivateProfileString(m_csAppName,csKeyName,pcValue,m_csIniFilePath);
	};

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    WriteString
	//
	//  PARAMETER
	//    csKeyName L[
	//    csValue   Zbgl
	//
	//  SUMMARY
	//    CStringinit@Cɏ݂܂
	//
	//  EXPLANATION
	//    CStringinit@Cɏ݂܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void WriteString(CString csKeyName,	// L[
				CString csValue)				// Zbgl
	{
		WritePrivateProfileString(m_csAppName,csKeyName,csValue,m_csIniFilePath);
	};

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    ReadInt
	//
	//  PARAMETER
	//    csKeyName L[
	//    nDefValue ftHgl
	//
	//  SUMMARY
	//    intinit@Cǂݍ
	//
	//  EXPLANATION
	//    intinit@Cǂݍ
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline int ReadInt(CString csKeyName,		// L[
				int nDefValue)					// ftHgl
	{
		return GetPrivateProfileInt(m_csAppName,csKeyName,nDefValue,m_csIniFilePath);
	}

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    ReadFloat
	//
	//  PARAMETER
	//    csKeyName L[
	//    fDefValue ftHgl
	//
	//  SUMMARY
	//    floatinit@Cǂݍ
	//
	//  EXPLANATION
	//    floatinit@Cǂݍ
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline float ReadFloat(CString csKeyName,	// L[
				float fDefValue)				// ftHgl
	{
		char work1[128];
		char work2[128];
		_gcvt_s(work1,128,fDefValue,8);
		GetPrivateProfileString(m_csAppName,csKeyName,work1,work2,128,m_csIniFilePath);
		return (float)atof(work2);
	}

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    ReadDouble
	//
	//  PARAMETER
	//    csKeyName L[
	//    dDefValue ftHgl
	//
	//  SUMMARY
	//    doubleinit@Cǂݍ
	//
	//  EXPLANATION
	//    doubleinit@Cǂݍ
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline double ReadDouble(CString csKeyName,	// L[
				double dDefValue)				// ftHgl
	{
		char work1[128];
		char work2[128];
		_gcvt_s(work1,128,dDefValue,64);
		GetPrivateProfileString(m_csAppName,csKeyName,work1,work2,128,m_csIniFilePath);
		return atof(work2);
	}

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//   ReadBool
	//
	//  PARAMETER
	//    csKeyName  L[
	//    bDdefValue ftHgl
	//
	//  SUMMARY
	//    boolinit@Cǂݍ
	//
	//  EXPLANATION
	//    boolinit@Cǂݍ
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline bool ReadBool(CString csKeyName,		// L[
				bool bDdefValue)				// ftHgl
	{
		char work[128];
		GetPrivateProfileString(m_csAppName,csKeyName,(bDdefValue?"true":"false"),work,128,m_csIniFilePath);
		CString TrueString("true");
		CString CheckString(work);
		return (TrueString == CheckString);
	}

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    ReadString
	//
	//  PARAMETER
	//    csKeyName  L[
	//    csDefValue ftHgl
	//    pcRead     obt@
	//    nLen       obt@TCY
	//
	//  SUMMARY
	//    init@Cǂݍ
	//
	//  EXPLANATION
	//    init@Cǂݍ
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void ReadString(CString csKeyName,	// L[
				CString csDefValue,				// ftHgl
				char* pcRead,					// obt@
				int nLen)						// obt@TCY
	{
		GetPrivateProfileString(m_csAppName,csKeyName,csDefValue,pcRead,nLen,m_csIniFilePath);
	}

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    ReadString
	//
	//  PARAMETER
	//    csKeyName  L[
	//    csDefValue ftHgl
	//
	//  SUMMARY
	//    CStringinit@Cǂݍ
	//
	//  EXPLANATION
	//    CStringinit@Cǂݍ
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline CString ReadString(CString csKeyName,	// L[
				CString csDefValue)					// ftHgl
	{
		char work[256+1];
		GetPrivateProfileString(m_csAppName,csKeyName,csDefValue,work,256,m_csIniFilePath);
		return CString(work);
	}

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    IsExist
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    init@C݂邩`FbN
	//
	//  EXPLANATION
	//    init@C݂邩`FbN
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline bool IsExist()
	{
		FILE* fp;
		fopen_s(&fp,m_csIniFilePath, "r");
		if(fp) {
			fclose(fp);
			return true;
		}
		return false;
	}

private:
	CString	m_csAppName;				// INI APP
	CString	m_csIniFilePath;			// INIt@CpX
};

#endif	// _INI_CONTROL_H End
