// SVI3DDEF.h : SVI摜̓Cu[gp邽߂̃wb_[t@C
//
/////////////////////////////////////////////////////////////////////////////

#if !defined INC_SVI3DDEF
#define INC_SVI3DDEF

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// T|[gECuEG[R[h`
#define	SVIUSB20_RET_NORMAL				0x1
#define	SVIUSB20_RET_ERROR_DEVICE		0xe0000000
#define	SVIUSB20_RET_ERROR_DEVOPEN		0xf0000001
#define	SVIUSB20_RET_ERROR_MULTIOPEN	0xf0000002
#define	SVIUSB20_RET_ERROR_NOOPEN		0xf0000003
#define	SVIUSB20_RET_ERROR_PARAMETER	0xf0000004
#define	SVIUSB20_RET_ERROR_COM			0xf0000005
#define	SVIUSB20_RET_ERROR_NOIDLE		0xf0000006
#define	SVIUSB20_RET_ERROR_FMUPDATE_T	0xf0000007
#define	SVIUSB20_RET_ERROR_FPUPDATE_T	0xf0000008
#define	SVIUSB20_RET_ERROR_GSTS2_T		0xf0000009
#define	SVIUSB20_RET_ERROR_MDATA_T		0xf000000a
#define	SVIUSB20_RET_ERROR_SVI			0xf1000000

// t@[AFPGAAbvf[gIĎ^CAEgl̒`
#define	DEF_FIRMUPDATE_TIMEOUT	15	// 1:1sec 15b
#define	DEF_FPGAUPDATE_TIMEOUT	15	// 1:1sec 15b
#define	DEF_GSTS2_TIMEOUT		50	// 1:10msec 500~b
#define	DEF_MONGET_TIMEOUT		10	// 1:100msec 1b

// SVI3D1_Open() p[^p`
#define	SVIUSB20_APP_WHO_REC	1L
#define	SVIUSB20_APP_WHO_CTL	2L

typedef struct _READWRITE_BLOCK {
	USHORT	Off_High;	// Destination Offset (bit47-bit32)
	ULONG	Off_Low;	// Destination Offset (bit31-bit00)
	ULONG	Quad_dat;	// Quadlet Data
} READWRITE_BLOCK, *PREADWRITE_BLOCK;

// SVI3D1_GetStatus() p[^p`
#define SVI_STS_SUCCESS        0x0001  // I
#define SVI_STS_FRAMEPENDING   0x0002  // I (ۗt[/f[^)
#define SVI_STS_CAPCANCELED    0x0003  // I (Lv`~ꂽ)
#define SVI_STS_BUSY           0x0011  // rW[ŃR}hsłȂ
#define SVI_STS_RECOVERYMODE   0x0012  // Jo[[ĥ߃R}hsłȂ
#define SVI_STS_I2CACTIVE      0x0013  // I2CRg[ANeBu
#define SVI_STS_CMD_INVALID    0x0101  // R}hsł
#define SVI_STS_PRM_INVALID    0x0102  // p[^sł
#define SVI_STS_SEQ_INVALID    0x0103  // pPbg̔sV[PXsł
#define SVI_STS_CAM_POWER_OFF  0x0104  // JdOFFł
#define SVI_STS_I2C_ACKTIMEOUT 0x0601  // I2CŃX[uACKMł^CAEg
#define SVI_STS_I2C_PRETIMEOUT 0x0602  // I2CŃv^CAEg
#define SVI_STS_I2C_POSTTIMEOUT 0x0603 // I2CŃ|Xg^CAEg
#define SVI_STS_USB_ERROR      0x0C01  // USBʐMɃG[
#define SVI_STS_UPDATE_INVALID 0x0E01  // W[f[^sł
#define SVI_STS_FROMERS_ERROR  0x0E02  // tbV[̏Ɏs
#define SVI_STS_FROMWT_ERROR   0x0E03  // tbV[݂̏Ɏs
#define SVI_STS_INTERNAL_ERROR 0x0F01  // G[
#define SVI_STS_RESOURCE_ERROR 0x0F02  // \[XsďsłȂ

#define	SVI_STS_ERR_MASK			0xF00
#define	SVIUSB20_GETSTATUS_STS_OK	SVI_STS_SUCCESS

typedef struct _GET_STATUS {
	ULONG	ulBasicStatus;		// 捞n[hEFÅ{Xe[^Xi1H:Ȃ:ُj
	ULONG	ulHWVersion;		// n[hEFÃo[Wԍ
	ULONG	ulFWVersion;		// t@[EFÃo[Wԍ
	ULONG	ulOPStatus;			// ݂̓샂[h
								//	0:AChA1:j^O
								//	2:R[fBOA8:Abvf[g
	ULONG	ulStartupStatus;	// t@[EFANXe[^Xi0:m[}A1:Joj
	ULONG	ulOrgSizeW;			// Jo͂Ă摜TCY̕
	ULONG	ulOrgSizeH;			// Jo͂Ă摜TCY̍
	ULONG	ulCutout_x;			// IWi摜̍[̐؂o͈͂̍[XW
	ULONG	ulCutout_y;			// IWi摜̍[̐؂o͈͂̍[YW
	ULONG	ulCutSizeW;			// ؂ỏ摜TCY̕
	ULONG	ulCutSizeH;			// ؂ỏ摜TCY̍
	ULONG	ulCamStatus;		// JXe[^X
								//	D0-7:MXe[^X
								//	D8-15:fW^ff[^
} GET_STATUS, *PGET_STATUS;

// SVI3D1_SetParam() p[^p`
#define	SVIUSB20_SETPARAM_BIT0	0x1
#define	SVIUSB20_SETPARAM_BIT1	0x2
#define	SVIUSB20_SETPARAM_BIT2	0x4
#define	SVIUSB20_SETPARAM_BIT3	0x8
#define	SVIUSB20_SETPARAM_BIT4	0x10
#define	SVIUSB20_SETPARAM_BIT5	0x20
#define	SVIUSB20_SETPARAM_BIT6	0x40
#define	SVIUSB20_SETPARAM_SPEED_100		0x0
#define	SVIUSB20_SETPARAM_SPEED_200		0x1
#define	SVIUSB20_SETPARAM_SPEED_400		0x1
#define	SVIUSB20_SETPARAM_CAMPOWER_OF	0x0
#define	SVIUSB20_SETPARAM_CAMPOWER_ON	0x1
#define	SVIUSB20_SETPARAM_I2CSPEED_4	0x0
#define	SVIUSB20_SETPARAM_I2CSPEED_2	0x1
#define	SVIUSB20_SETPARAM_I2CSPEED_1	0x2

typedef struct _SET_PARAM {
	ULONG	ulParamBitFlag;		// ȉ̃p[^̗L(1)/(0)w肷
								//	SVIUSB20_SETPARAM_BIT0 : 摜ʒm
								//	SVIUSB20_SETPARAM_BIT1 : JdXCb`
								//	SVIUSB20_SETPARAM_BIT2 : I2CXs[h
								//	SVIUSB20_SETPARAM_BIT3 : \
								//	SVIUSB20_SETPARAM_BIT4 : \
								//	SVIUSB20_SETPARAM_BIT5 : VSYNCfAT[gtO
								//	SVIUSB20_SETPARAM_BIT6 : j^O[htO
								//@wORZqgp
	ULONG	ulVsyncFlag;		// VSYNCfAT[gtO	0@:@fAT[g҂ - l
								//							1@:@fAT[g҂Ȃ
	ULONG	ulCamPower;			// JdXCb`i0:OFFA1:ONj
	ULONG	ulI2CSpeed;			// I2CXs[hi0:400KbpsA1:200KbpsA2:100Kbpsj
	ULONG	ulMonMode;			// j^O[hi0 : ޯ̧A1 : ݸޯ̧j- lF0
	ULONG	ulPixelInfo;		// 摜ʒm	bit0-1 : F(1or2or3)
								//				bit2   : 1F̃rbg(0:8bit,1:16bit)
} SET_PARAM, *PSET_PARAM;

typedef struct _MONITOR_PARAM {
	ULONG	ulCutout_x;			// IWi摜̍[̐؂o͈͂̍[XW
	ULONG	ulCutout_y;			// IWi摜̍[̐؂o͈͂̍[YW
	ULONG	ulCutout_w;			// ؂o͈͂̕ij
	ULONG	ulCutout_h;			// ؂o͈͂̍ij
} MONITOR_PARAM, *PMONITOR_PARAM;

typedef struct _MON_HEADER {
	ULONG	ulStatus;			// sʂ̃Xe[^Xi1H:Ȃ:ُj
	ULONG	ulPendingInfo;		// ۗt[
	ULONG	ulOrgSizeW;			// Jo͂Ă摜TCY̕
	ULONG	ulOrgSizeH;			// Jo͂Ă摜TCY̍
	ULONG	ulCutout_x;			// IWi摜̍[̐؂o͈͂̍[XW
	ULONG	ulCutout_y;			// IWi摜̍[̐؂o͈͂̍[YW
	ULONG	ulMonSizeW;			// ؂ỏ摜TCY̕
	ULONG	ulMonSizeH;			// ؂ỏ摜TCY̍
	ULONG	ulFrameRate;		// Jo͂Ă摜̃t[[g
	ULONG	ulLoseFrame;		// Ot[{t[Ԃɔjt[
	ULONG	ulOpticalAxisInfo;	// Ot[{t[Ԃɔjt[
	USHORT	usCursorX;			// \J[\XW
	USHORT	usCursorY;			// \J[\YW
	USHORT	usWakuLeftX;		// g̍XW
	USHORT	usWakuLeftY;		// g̍YW
	USHORT	usWakuRightX;		// g̉EXW
	USHORT	usWakuRightY;		// g̉EYW
	ULONG	ulReserve1;			// \
	ULONG	ulVsyncReadLen;		// Vǂݏõf[^i0-448j
	ULONG	ulVsyncVal[448/4];	// Vǂݏõf[^
} MON_HEADER, *PMON_HEADER;

typedef struct _RECORD_PARAM {
	ULONG	ulFrameCount;		// R[fBOt[
	ULONG	ulBufferCount;		// R[fBOTCYioCgj
	ULONG	ulRecMode;			// R[fBO[h
								//  bit31i0:RecordingA1:Monitoring&SaveMemj
								//  bit30-bit01i\j
								//  bit00i0:t[A1:TCYj
} RECORD_PARAM, *PRECORD_PARAM;

#pragma pack(1)
typedef struct _REC_HEADER {
	ULONG	ulStatus;			// sʂ̃Xe[^Xi1H:Ȃ:ُj
	ULONG	ulPendingInfo;		// ۗR[fBOf[^TCY
	UCHAR	ubFirmVersion;		// t@[EFAo[Wԍ
	UCHAR	ubHardVersion;		// n[hEFAo[Wԍ
	USHORT	usNumChannel;		// `li1hŒj
	UCHAR	ubCompFlag;			// ktOi0:񈳏kA1:kj
	ULONG	ulNumScan;			// f[^TCY
	USHORT	usDataWidth;		// f[^i0:8bitsA1:16bitsj
	UCHAR	ulReserve[1];		// \
	ULONG	ulRecHeaderSize;	// Monitoring&Save2̃R[fBOt[wb_[TCY
} REC_HEADER, *PREC_HEADER;
#pragma pack()

// SVI3D1_I2CStart() p[^p`
#define	SVIUSB20_I2CSTART_PARAM_OFF	0x0	// I2C[hV[PXȂ
#define	SVIUSB20_I2CSTART_PARAM_ON	0x1	// I2C[hV[PX

// SVI3D1_I2COneByteRead() p[^p`
#define	SVIUSB20_I2CREADSET_PARAM_NOACK	0x0	// I2C[hACKMȂ
#define	SVIUSB20_I2CREADSET_PARAM_ACK	0x1	// I2C[hACKM

#endif
