/*FILE------------------------------------------------------------------------*/
//
//  SVIsamDlg.h : wb_[ t@C
//
//  SUMMARY
//    SVI SDK Main Dialog header
//
//  WRITER
//    NetVision
//
//  HISTORY
//    2005/05/30 New creation
//
/*FILE------------------------------------------------------------------------*/

#if !defined(AFX_SVIDEMODLG_H__0172972E_A25B_4CE8_BE48_CEC78FD3650A__INCLUDED_)
#define AFX_SVIDEMODLG_H__0172972E_A25B_4CE8_BE48_CEC78FD3650A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxadv.h>

#include "DoubleBuffer.h"
#include "Display.h"
#include "IniControl.h"
#include "SVIcbDlg.h"
#include "SVItrnsfersetDlg.h"

/*CLASS-----------------------------------------------------------------------*/
//  NAME
//    CSVIsamDlg
//
//  SUMMARY
//    SVI SDK main dialog class.
//
//  EXPLANATION
//    Each operation of monitoring, recording, a color bar, and I2C is defined.
//
//  REMARKS
//    NONE
//
/*CLASS-----------------------------------------------------------------------*/
class CSVIsamDlg : public CDialog
{
// \z
public:
	CSVIsamDlg(CWnd* pParent = NULL);	// W̃RXgN^

// _CAO f[^
	//{{AFX_DATA(CSVIsamDlg)
	enum { IDD = IDD_SVISAM_DIALOG };
	CScrollBar	m_ImageScrollH;
	CScrollBar	m_ImageScrollW;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CSVIsamDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	HICON m_hIcon;						// {{AFX_DATA(CSVIsamDlg)

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CSVIsamDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnCb();
	afx_msg void OnMs1();
	afx_msg void OnBMPSave();
	afx_msg void OnCmdSetting();
	afx_msg void OnParaOpen();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnDestroy();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnInfoup();
	afx_msg void OnOp4();
	afx_msg void OnButtonSend();
	afx_msg void OnButtonRead();
	afx_msg void OnButtonWrite();
	afx_msg void OnButton8();
	afx_msg void OnButton9();
	afx_msg void OnOp2();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    OnOK
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    OK{^
	//
	//  EXPLANATION
	//    ENTERL[ł̏I
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	virtual void OnOK() {};

	///////////////////////////////////////////////////
	// j^O֘A
	BOOL	m_bMonStop;					// j^O~tO
	BOOL	m_bMonErr;					// j^OG[tO

	int m_nMonRate[4];						// j^Ot[[g
	int m_nCamRate[4];						// Jt[[g
	int m_nCamLoseRate[4];					// J[g

	CDoubleBuffer	m_dbMonDB;			// j^Op_uobt@
	CDoubleBuffer	m_dbMultiMonDB[MULTI_MONITOR];			// TlCj^Op_uobt@

	CDisplay m_SingleMonitor;			// VOj^Op摜\GA

	CDisplay m_MultiMonitor[MULTI_MONITOR];	// }`j^Op摜\G
											// A

	///////////////////////////////////////////////////
	// ؂o֘A
	MONITORING_CUTOUT_SETTING	m_MonCutSet;	// j^O؂oݒ

	///////////////////////////////////////////////////
	// 샂[h

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    IsSMon
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    VOj^O[hԎ擾
	//
	//  EXPLANATION
	//    VOj^O[hǂ擾܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline BOOL IsSMon() { return (m_nMode == DEF_DIS_MODE_SMON); };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    IsMMon
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    }`j^O[hԎ擾
	//
	//  EXPLANATION
	//    }`j^O[hǂ擾܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline BOOL IsMMon() { return (m_nMode == DEF_DIS_MODE_MMON); };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    IsRec
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    R[fBO[hԎ擾
	//
	//  EXPLANATION
	//    R[fBO[hǂ擾܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline BOOL IsRec()  { return (m_nMode == DEF_DIS_MODE_REC); };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    IsRecPlay
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    R[fBOĐ[hԎ擾
	//
	//  EXPLANATION
	//    R[fBOĐ[hǂ擾܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline BOOL IsRecPlay() { return (m_nMode == DEF_DIS_MODE_RPLAY); };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    IsNon
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    Ԏ擾
	//
	//  EXPLANATION
	//    삩ǂ擾܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline BOOL IsNon()
	{
		switch(m_nMode)
		{
		case DEF_DIS_MODE_SMON :
		case DEF_DIS_MODE_MMON :
		case DEF_DIS_MODE_REC : return FALSE;
		default : return TRUE;
		}
	};

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    SetSMon
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    VOj^O[hݒ
	//
	//  EXPLANATION
	//    VOj^O[hł邱Ƃݒ肵܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void SetSMon() { m_nMode = DEF_DIS_MODE_SMON; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    SetMMon
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    }`j^O[hݒ
	//
	//  EXPLANATION
	//    }`j^O[htOݒ肵܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void SetMMon() { m_nMode = DEF_DIS_MODE_MMON; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    SetRec
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    R[fBO[hݒ
	//
	//  EXPLANATION
	//    R[fBO[htOݒ肵܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void SetRec()  { m_nMode = DEF_DIS_MODE_REC; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    SetRecPlay
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    R[fBOĐ[hݒ
	//
	//  EXPLANATION
	//    R[fBOĐ[htOݒ肵܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void SetRecPlay() { m_nMode = DEF_DIS_MODE_RPLAY; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    SetNone
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    샂[hݒ
	//
	//  EXPLANATION
	//    샂[htOݒ肵܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline void SetNon()  { m_nMode = DEF_DIS_MODE_NON; };

	///////////////////////////////////////////////////
	// YUV->RGB֘A
	BOOL ColorBar(CPoint MousePoint);	// J[o[

	CSVIcbDlg*	m_pSVIcbDlg;			// CSVIcbDlg̃|C^

private:
	int m_MonTimeout;
	int m_MonMode;
	void WriteIniMonMode();
	void ReadIniMonMode();

	///////////////////////////////////////////////////
	// j^O֘A
	BOOL MonStart();	// j^OJn

	BOOL MonStop();	// j^O~

	void ShowMon(BOOL bShow);	// 摜\GA؂ւ

	BOOL MonDraw();	// j^Ot[̕`

	void FrameRate();	// t[[g\

	static UINT	MonitoringThread1(LPVOID pParam);		// ch1:MonitoringXbh`
	static UINT	MonitoringThread2(LPVOID pParam);		// ch2:MonitoringXbh`
	static UINT	MonitoringThread3(LPVOID pParam);		// ch3:MonitoringXbh`
	static UINT	MonitoringThread4(LPVOID pParam);		// ch4:MonitoringXbh`
//
	CWinThread*	m_pMonitoringThread1;					// ch1:MonitoringXbh|C^
	CWinThread*	m_pMonitoringThread2;					// ch2:MonitoringXbh|C^
	CWinThread*	m_pMonitoringThread3;					// ch3:MonitoringXbh|C^
	CWinThread*	m_pMonitoringThread4;					// ch4:MonitoringXbh|C^

	int m_nMode;						// j^O[h

	///////////////////////////////////////////////////
	// CtH[V֘A
	BOOL Information();

	///////////////////////////////////////////////////
	// YUV->RGB֘A
	void YUVtoRGB(LPBYTE lpRGB, LPBYTE lpYUV, int nW, int nH, int nType);	// YUV->RGBϊ

	// YUV->RGBϊW
	int m_X140200[256];					// YUV -> RϊUW
	int m_X034414[256];					// YUV -> GϊUW
	int m_X071414[256];					// YUV -> GϊVW
	int m_X177200[256];					// YUV -> BϊVW

	BOOL GetPixelColor(CPoint* pMousePoint, DWORD* pdwRGB, DWORD* pdwYUV);

	///////////////////////////////////////////////////
	// ʊ֘A
	BOOL BitmapSave(CString csBmpPath, CFrameData* pRGBFrame);	// rbg}bvۑ

	void SetScroll(CFrameData* pFrame);	// XN[o[ݒ肷

	void InitScroll();	// XN[o[

	CFrameData m_RGBFrame;				// RGBt[obt@
															// O؂oݒ

	///////////////////////////////////////////////////
	// Picture Type֘A
	int m_PicType_1;		// Board_1 PictureType
	int m_PicType_2;		// Board_2 PictureType
	int m_PicType_3;		// Board_3 PictureType
	int m_PicType_4;		// Board_4 PictureType
	int m_RawDpe;			// RAWf[^DPEON/OFFtO
	int m_VSNeg_1;			// Board_1 Input VSync Invert
	int m_VSNeg_2;			// Board_1 Input VSync Invert
	int m_VSNeg_3;			// Board_1 Input VSync Invert
	int m_VSNeg_4;			// Board_1 Input VSync Invert

	///////////////////////////////////////////////////
	// INIt@CANZX֐
	void ReadIniCutout();	// ؂oݒɊւINIt@C̓ǂݍ

	void WriteIniCutout();	// ؂oݒɊւINIt@C̏

	void ReadIniPicType(); // Picture TypeݒɊւINIt@CǍ

	void WriteIniPicType(); // Picture TypeݒɊւINIt@C

	void ReadIniSetButtonName();	// [U[{^ݒɊւINIt@C
	void ReadIniBoardNo();			// SVI-03{[hԍݒɊւINIt@C
	int	m_BoardNo;					// SVI-03{[hԍ

	///////////////////////////////////////////////////
	// ̑
	BOOL CamPower(BOOL bCamCheck = FALSE);

	CString GetProductVersion();

	void SetMonScrollPos(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar, BOOL bScroll);

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    SetMask
	//
	//  PARAMETER
	//    nValue 臒l
	//
	//  SUMMARY
	//     YUV->RGBϊ̃}XN
	//
	//  EXPLANATION
	//     YUV->RGBϊ̃}XNݒ肵܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline BYTE SetMask(int nValue)
	{
		if(nValue < 0) nValue = 0;
		else if(nValue > 255) nValue = 255;
		return (BYTE)nValue;
	};

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    YUV
	//
	//  PARAMETER
	//    lpRGB   RGBf
	//    pY      Y
	//    pU      U
	//    pV      V
	//
	//  SUMMARY
	//    YUV->RGB (1pixel)
	//
	//  EXPLANATION
	//    YUV->RGB  1pixel ϊs܂
	//
	//  RETURN
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	inline LPBYTE YUV(LPBYTE lpRGB, int Y, int U, int V)
	{
		// BvZ
		*lpRGB++ = SetMask((int)((Y + *(m_X177200 + U))/YUV_OFFSET));

		// GvZ
		*lpRGB++ = SetMask((int)((Y + *(m_X034414 + U) + *(m_X071414 + V))/YUV_OFFSET));

		// RvZ
		*lpRGB++ = SetMask((int)((Y + *(m_X140200 + V))/YUV_OFFSET));

		return lpRGB;
	}

	///////////////////////////////////////////////////
	// p[^t@C͊֐

	int GetI2cCmdForString(char *pcStr, int len, unsigned char *pucCmd, int *bytelen);
	int SkipSpace( char *pszDest);
public:
	void ReadIniBinarization();
	bool m_bBinarizationFlag;
	int	m_iBinarization_Thres;
	void ReadIniLensShading();
	bool m_bLensShadingFlag;
	int	m_iLensShading_Step;
	int	m_iLensShading_Thres;
	int m_MonState;
	int DSPBlockWrite( DWORD dwSlave, DWORD dwSubAddress, DWORD dwWriteMode, DWORD dwSendCnt, PUCHAR pucSendBuf );	// Block write
	int DSPBlockRead( DWORD dwSlave, DWORD dwSubAddress, DWORD dwReadMode, DWORD dwRcvCnt, PUCHAR pucRcvBuf );	// Block read
	int DSPBlockWrite2( int id, DWORD dwSlave, DWORD dwSubAddress, DWORD dwWriteMode, DWORD dwSendCnt, PUCHAR pucSendBuf );	// Block write
	int DSPBlockRead2( int id, DWORD dwSlave, DWORD dwSubAddress, DWORD dwReadMode, DWORD dwRcvCnt, PUCHAR pucRcvBuf );	// Block read
	int m_selid;
	void WriteIniMultipleTransfer();
	void ReadIniMultipleTransfer();
	CString m_MultiFilePath1;
	CString m_MultiFilePath2;
	CString m_MultiFilePath3;
	CString m_MultiFilePath4;
	afx_msg void OnBnClickedButton5();
	afx_msg void OnBnClickedButton6();
	afx_msg void OnBnClickedSet1();
	void SingleMonitorViewChange(int nID);
	afx_msg void OnBnClickedSet2();
	afx_msg void OnBnClickedSet3();
	afx_msg void OnBnClickedSet4();
	BOOL ParamWrite(LPCTSTR lpstrFileName);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_SVIDEMODLG_H__0172972E_A25B_4CE8_BE48_CEC78FD3650A__INCLUDED_)
