/*FILE------------------------------------------------------------------------*/
//
//  SviControl0.cpp
//
//  SUMMARY
//    SVI I2C control core class
//
//  WRITER
//    Net Vision
//
//  HISTORY
//    2013/10/xx New creation
//
/*FILE------------------------------------------------------------------------*/
#include "stdafx.h"
#include "SviControl1.h"

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    CSviControl
//
//  PARAMETER
//
//  SUMMARY
//    RXgN^
//
//  EXPLANATION
//    RXgN^
//
//  RETURN
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
CSviControl1::CSviControl1()
: m_bExist(false)
{
	m_bDevOpen = FALSE;

	// T|[gCȕ
	SVI3D1_Init();
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    ~CSviControl
//
//  PARAMETER
//
//  SUMMARY
//    fXgN^
//
//  EXPLANATION
//    fXgN^
//
//  RETURN
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
CSviControl1::~CSviControl1()
{
	// SVICuI
	SVI3D1_End();
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    SviOpen
//
//  PARAMETER
//
//  SUMMARY
//    SVI{[hI[v
//
//  EXPLANATION
//    SVI{[hI[v
//
//  RETURN
//    SVI G[R[h
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
DWORD CSviControl1::SviOpen()
{
	DWORD ret = SVIUSB20_RET_NORMAL;
	ULONG ulNum;
	PULONG pulNoBuf;
	ULONG i;
	ULONG ulBoadNo = m_BoardNo;

	if(IsClose()) {
		// VOibN
		CSingleLock obLock(&m_csSync, true);

		m_csSync.Lock();

		// foCXI[v
		// SVI-03{[h
		ret = SVI3D1_EnumDevice(SVIUSB20_APP_WHO_REC, &ulNum, NULL);
		if(ret == SVIUSB20_RET_NORMAL){
			if(ulNum > 0 && ulNum < 9){
				pulNoBuf = new ULONG[ulNum];
				ret = SVI3D1_EnumDevice(SVIUSB20_APP_WHO_REC, &ulNum, pulNoBuf);
				if(ret == SVIUSB20_RET_NORMAL){
					for(i = 0; i < ulNum; i++){
						if(((*(pulNoBuf+i)>>16)&0x7) == ulBoadNo) break;
					}
					if(i < ulNum){
						// foCXI[v
						SVI3D1_DeviceSelect(*(pulNoBuf+i));
						ret = SVI3D1_Open(SVIUSB20_APP_WHO_REC);
						if(ret == SVIUSB20_RET_NORMAL){
							// I[v
							m_bDevOpen = TRUE;
						}else{
AfxMessageBox("Error2");
						}
					}else{
							CString st1;
							st1.Format("ulBoadNo=%08x",ulBoadNo);
							AfxMessageBox(st1);
						for(i = 0; i < ulNum; i++){
							CString st;
							st.Format("3-[%d]:num=%08x",i,*(pulNoBuf+i));
							AfxMessageBox(st);
						}
					}
				}else{
AfxMessageBox("Error4");
				}
				delete [] pulNoBuf;
			}
		}
		if(m_bDevOpen != TRUE){
			// I[vG[
			CString csMsg;
			csMsg.Format("SviOpen Error return[0x%08X]\n", ret);
			TRACE(csMsg);
			ret = SVIUSB20_RET_ERROR_DEVOPEN;
		}

		// VOiAbN
		m_csSync.Unlock();
	}

	return ret;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    SviClose
//
//  PARAMETER
//
//  SUMMARY
//    SVI{[hN[Y
//
//  EXPLANATION
//    SVI{[hN[Y
//
//  RETURN
//    SVI G[R[h
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
DWORD CSviControl1::SviClose()
{
	DWORD ret = SVIUSB20_RET_NORMAL;

	if(IsOpen()) {
		// VOibN
		CSingleLock obLock(&m_csSync, true);

		m_csSync.Lock();

		// foCXN[Y
		ret = SVI3D1_Close(SVIUSB20_APP_WHO_REC);
		if(ret == SVIUSB20_RET_NORMAL) {
			// I[v
			m_bDevOpen = FALSE;
			// foCXJ
			SVI3D1_DeviceRelease();
		}
		else {
			// N[YG[
			CString csMsg;
			csMsg.Format("SVIUSB20_Close Error return[0x%08X]\n", ret);
			TRACE(csMsg);
		}

		// VOiAbN
		m_csSync.Unlock();
	}

	return ret;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    SetStatus
//
//  PARAMETER
//    ulParamBitFlag  [IN] wORZqgp
//    ulVsyncFlag     [IN] VSYNCfAT[gtO(0:fAT[g҂A1@:@fAT[g҂Ȃ )
//    ulCamPower      [IN] JdXCb`i0:OFFA1:ONj
//    ulI2CSpeed      [IN] I2CXs[hi0:400KbpsA1:200KbpsA2:100Kbpsj
//    ulMonMode       [IN] j^O[hi0:DoubleA1:Ringj
//    ulPixelInfo     [IN] 摜ʒm	bit0-1:F(1or2or3)Abit2:1F̃rbg(0:8bit,1:16bit)
//
//  SUMMARY
//    JXe[^XZbg
//
//  EXPLANATION
//    JXe[^XZbg
//
//  RETURN
//    SVI G[R[h
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
DWORD CSviControl1::SetStatus(
							ULONG ulParamBitFlag,		// [IN] wORZqgp
							ULONG ulVsyncFlag,			// [IN] VSYNCfAT[gtO(0:fAT[g҂A1@:@fAT[g҂Ȃ )
							ULONG ulCamPower,			// [IN] JdXCb`i0:OFFA1:ONj
							ULONG ulI2CSpeed,			// [IN] I2CXs[hi0:400KbpsA1:200KbpsA2:100Kbpsj
							ULONG ulMonMode,			// [IN] j^O[hi0:DoubleA1:Ringj
							ULONG ulPixelInfo )			// [IN] 摜ʒm	bit0-1:F(1or2or3)Abit2:1F̃rbg(0:8bit,1:16bit)
{
	SET_PARAM	SetParam;
	int			ret;

	// p[^ݒ
	SetParam.ulParamBitFlag		= ulParamBitFlag;
	SetParam.ulVsyncFlag		= ulVsyncFlag;
	SetParam.ulCamPower			= ulCamPower;
	SetParam.ulI2CSpeed			= ulI2CSpeed;
	SetParam.ulMonMode			= ulMonMode;
	SetParam.ulPixelInfo		= ulPixelInfo;

	// 捞n[hEFAɃn[hEFAݒʒm܂
	ret = SVI3D1_SetParam(&SetParam);
	if(ret != SVIUSB20_RET_NORMAL) {
		CString		csMsg;
		csMsg.Format("SVIUSB20_SetParam Error return[0x%08X]\n", ret);
		TRACE(csMsg);
	}

	return ret;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    Initialize
//
//  PARAMETER
//
//  SUMMARY
//    SVICjVCY
//
//  EXPLANATION
//    SVICjVCY
//
//  RETURN
//    SVI G[R[h
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
DWORD CSviControl1::Initialize()
{
	int			i;
	DWORD		ret;
	GET_STATUS	GetStatus;

	// VOibN
	CSingleLock obLock(&m_csSync, true);

	m_csSync.Lock();

	for(i = 0 ; i < DEV_INIT ; i++) {

		// Xe[^X擾s܂
		ret = SVI3D1_GetStatus(&GetStatus);
		if( ret != SVIUSB20_RET_NORMAL ) {
			TRACE("SVIInit GetStatus[0x%08X] ulBasicStatus[0x%08X] count[%d]\n", ret, GetStatus.ulBasicStatus, i);
			continue;
		}

		break;
	}

	// VOiAbN
	m_csSync.Unlock();

	return ret;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    MonStart
//
//  PARAMETER
//    ulCutout_x [IN] ؂JnXʒu
//    ulCutout_y [IN] ؂JnYʒu
//    ulCutout_w [IN] ؂艡
//    ulCutout_h [IN] ؂c
//
//  SUMMARY
//    j^OJn
//
//  EXPLANATION
//    j^OJn
//
//  RETURN
//    SVI G[R[h
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
DWORD CSviControl1::MonStart(
							ULONG ulCutout_x,	// [IN] ؂JnXʒu
							ULONG ulCutout_y,	// [IN] ؂JnYʒu
							ULONG ulCutout_w,	// [IN] ؂艡
							ULONG ulCutout_h) 	// [IN] ؂c
{
	DWORD ret;
	int i;
	GET_STATUS GetStatus;
	CString csMsg;

	if(IsClose()) {
		// foCXN[Y
		return SVIUSB20_RET_ERROR_DEVOPEN;
	}

	// VOibN
	CSingleLock obLock(&m_csSync, true);

	m_csSync.Lock();

	////////////////////////////////////////////////////////
	// j^OJn
	i = 0;
	m_StopMonTimeoutWait = TRUE;
	m_SleepMonTimeoutWait = FALSE;

	while(1) {

		if(m_SleepMonTimeoutWait == TRUE){
			Sleep(1000);
			i = 0;
			continue;
		}

		// Xe[^X擾s܂
		ret = SVI3D1_GetStatus( &GetStatus );

		if(ret != SVIUSB20_RET_NORMAL) {
			// Xe[^X擾G[
			m_csSync.Unlock();
			return ret;
		}

		// VSYNC/HSYNCmF
		if( GetStatus.ulOrgSizeW > 0 && GetStatus.ulOrgSizeH > 0 ) {
			break;
		}

		// VSYNC܂HSYNC
		// 5bxgC
		if( m_MonTimeout > 0 ) i++;
		if( (i > (m_MonTimeout*10)) || (m_StopMonTimeoutWait == FALSE) ) {
			// foCXN[Y
			m_csSync.Unlock();
			return SVIUSB20_RET_ERROR_SVI;
		}
		Sleep( 100 );
	}

	////////////////////////////////////////////////////////
	// j^OJn
	MONITOR_PARAM MonParam;

	MonParam.ulCutout_x	= ulCutout_x;
	MonParam.ulCutout_y	= ulCutout_y;
	MonParam.ulCutout_w	= ulCutout_w;
	MonParam.ulCutout_h	= ulCutout_h;

	// j^OX^[gʒm܂
	ret = SVI3D1_MonStart(&MonParam);
	if(ret != SVIUSB20_RET_NORMAL) {
		// j^OJnG[

		// j^OXgbv𔭍si\j
		SVI3D1_MonStop();

		if(ret == SVI_STS_BUSY) {
			// oXZbgs
			DevErrorBusReset();
		}

		csMsg.Format("SVIUSB20_MonStart Error return[0x%08X]\n", ret);
		TRACE(csMsg);

		// foCX̋}~
		DevErrorClose();
	}

	// VOiAbN
	m_csSync.Unlock();

	return ret;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//
//  PARAMETER
//
//  SUMMARY
//    j^O~
//
//  EXPLANATION
//    j^O~
//
//  RETURN
//    SVI G[R[h
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
DWORD CSviControl1::MonStop()
{
	DWORD ret;

	// j^OXgbv𔭍s
	ret = SVI3D1_MonStop();
	if(ret != SVIUSB20_RET_NORMAL) {
		CString csMsg;
		csMsg.Format("SVIUSB20_MonStop Error return[0x%08X]\n", ret);
		TRACE(csMsg);
		DevErrorBusReset();
	}

	return ret;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//
//  PARAMETER
//    pFrame
//    nPicType
//
//  SUMMARY
//    j^Of[^擾
//
//  EXPLANATION
//    j^Of[^擾
//
//  RETURN
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CSviControl1::MonGetData(CFrameData* pFrame, int nPicType)
{
	BOOL bSet = FALSE;
	DWORD ret;
	// VOibN
	CSingleLock obLock(&m_csSync, true);

	m_csSync.Lock();

	// gCJE^
	int	nRetry = 0;

	// j^Ot[擾[v
	while((nRetry < (m_MonTimeout*100)) || (m_MonTimeout == 0)) {
		// j^Ot[̎擾s

		// t[foCXŎ擾Ă邩mF
		if(IsFramePending(&ret)) {
			// t[mۂĂ

			// j^Owb_̎擾
			if(MonGetHeader(pFrame) != SVIUSB20_RET_NORMAL) {
				// j^Owb_̎擾s
				// [v甲Aj^OG[tOON
				CString ccc;
				ccc.Format("CH.1 Error MonHeader Err");
				AfxMessageBox(ccc);
				break;
			}

			// j^Ot[̎擾
			if(MonGetFrame(pFrame, nPicType) != SVIUSB20_RET_NORMAL) {
				// j^Ot[̎擾s
				// [v甲Aj^OG[tOON
				CString ccc;
				ccc.Format("CH.1 Error MonGetFrame Err");
				AfxMessageBox(ccc);
				break;
			}
			// t[擾tOON
			bSet = TRUE;
			break;
		}
		
		// IsFramePending擾SVIUSB20_RET_NORMALȊOł΃[vI
		if (ret != SVIUSB20_RET_NORMAL)
		{
			CString ccc;
			ccc.Format("CH.1 Error GetStatus2 Err");
			AfxMessageBox(ccc);
			break;
		}

		// t[foCXŊmۂĂȂꍇA
		// 10ms̃EFCgs
		if(m_MonTimeout > 0) nRetry++;
	}

	// VOiAbN
	m_csSync.Unlock();

	return bSet;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//
//  PARAMETER
//    pFrame
//
//  SUMMARY
//    j^Owb_擾
//
//  EXPLANATION
//    j^Owb_擾
//
//  RETURN
//    SVI G[R[h
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
DWORD CSviControl1::MonGetHeader(CFrameData* pFrame)
{
	DWORD ret;
	CString csMsg;
	MON_HEADER MonHeader;

	// j^Owb_[擾s܂
	while(1) {
		ret = SVI3D1_MonGetHeader(&MonHeader);
		if(ret != SVIUSB20_RET_NORMAL) {
			csMsg.Format("SVIUSB20_MonGetHeader Error return[0x%08X]\n", ret);
			TRACE(csMsg);

			if(ret == SVI_STS_BUSY) {
				DevErrorBusReset();
			}

			CString csErr;
			csErr.Format("MonGetHeader [%08X]", ret);
			AfxMessageBox(csErr);

			break;
		}
		if(MonHeader.ulMonSizeW <= 0 || MonHeader.ulMonSizeH <= 0) {
			DevErrorBusReset();
			SetStatus();
			csMsg.Format("SVIUSB20_MonGetHeader Error FrameSize[%x x %x]\n", MonHeader.ulMonSizeW, MonHeader.ulMonSizeH);
			TRACE(csMsg);
			ret = SVIUSB20_RET_ERROR_SVI;
			break;
		}

		pFrame->SetMonHeader(MonHeader);

		break;
	}

	return ret;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//
//  PARAMETER
//    pFrame
//    nPicType
//
//  SUMMARY
//    j^Ot[擾
//
//  EXPLANATION
//    j^Ot[擾
//
//  RETURN
//    SVI G[R[h
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
DWORD CSviControl1::MonGetFrame(CFrameData* pFrame, int nPicType) // <<< V1.3.0.0 modify
{
	DWORD ret;
	CString csMsg;
	ULONG ulRcvSize;
	ULONG ulGetSize;
	ULONG ulImageSize;

	// j^Ot[擾܂
	while(1) {
		// 摜TCY̌vZ
		if(nPicType == RAW8)
			ulImageSize = pFrame->GetMonHeader().ulMonSizeW * pFrame->GetMonHeader().ulMonSizeH * 1;
		else
			ulImageSize = pFrame->GetMonHeader().ulMonSizeW * pFrame->GetMonHeader().ulMonSizeH * 2;

		ulRcvSize = ((ulImageSize + 63) / 64) * 64;

		// obt@TCYƂ̔r
		if((ULONG)pFrame->GetBufferSize() != ulRcvSize) {
			// obt@̍Ċmۂs
			pFrame->ReReserv((int)ulRcvSize);
			pFrame->SetFrameLen((int)ulImageSize);
		}

		// j^Of[^1t[M܂
		ret = SVI3D1_MonGetFrame(pFrame->GetFramePointer(), ulRcvSize, &ulGetSize );
		if(ret != SVIUSB20_RET_NORMAL) {
			csMsg.Format("SVIUSB20_MonGetFrame Error return[0x%08X]\n", ret);
			TRACE(csMsg);

			if(ret == SVI_STS_BUSY) {
				DevErrorBusReset();
			}

			CString csErr;
			csErr.Format("SVIUSB20_MonGetFrame [%08X]", ret);
			AfxMessageBox(csErr);

			break;
		}

		// MTCYƎۂɎ擾TCYr
		if(ulRcvSize != ulGetSize) {
			// TCYقȂꍇ̓G[Ƃ
			csMsg.Format( "SVIUSB20_MonGetFrame Diff RecvSize Set[%d] Get[%d]\n", ulRcvSize, ulGetSize);
			TRACE(csMsg);
			ret = SVIUSB20_RET_ERROR_SVI;
			break;
		}

		break;
	}

	return ret;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//
//  PARAMETER
//    dwWriteMode
//    dwSlaveAdr
//    dwSendCnt
//    lpSendBuf
//
//  SUMMARY
//    I2C block write
//
//  EXPLANATION
//    I2C block write
//
//  RETURN
//    SVI G[R[h
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
DWORD CSviControl1::WriteBlock(DWORD dwWriteMode, DWORD dwSlaveAdr, DWORD dwSendCnt, PBYTE lpSendBuf)
{
	DWORD dwRet;

	// Critical section starts
	CSingleLock obLock(&m_csSync, true);
	m_csSync.Lock();

	// I2C 1ubN]sȂ܂
	dwRet = SVI3D1_I2COneBlockWrite( dwSlaveAdr, dwSendCnt + 1, dwWriteMode, lpSendBuf );

	// Critical section ends
	m_csSync.Unlock();

	return dwRet;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//
//  PARAMETER
//    dwReadMode
//    dwSlaveAdr
//    dwRcvCnt
//    lpRcvBuf
//
//  SUMMARY
//    I2C block read
//
//  EXPLANATION
//    I2C block read
//
//  RETURN
//    SVI G[R[h
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
DWORD CSviControl1::ReadBlock(DWORD dwReadMode, DWORD dwSlaveAdr, DWORD dwRcvCnt, PBYTE lpRcvBuf)
{
	DWORD dwRet;

	// Critical section starts
	CSingleLock obLock(&m_csSync, true);
	m_csSync.Lock();

	// I2C 1ubN]sȂ܂
	dwReadMode |= 0x80000000;
	dwRet = SVI3D1_I2COneBlockWrite( dwSlaveAdr, 1, dwReadMode, lpRcvBuf );
	if( dwRet != SVIUSB20_RET_NORMAL ) {
		TRACE("2------------------------------------------------------------------------------------------\n");
		m_csSync.Unlock();
		return dwRet;
	}
	if( dwRcvCnt ) {
		dwReadMode &= 0xFFFF7FFF;
		dwRet = SVI3D1_I2COneBlockRead( dwSlaveAdr, dwRcvCnt, dwReadMode, lpRcvBuf + 1 );
	}

	// Critical section ends
	m_csSync.Unlock();

	return dwRet;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//
//  PARAMETER
//    ulLen
//    ulWriteMode
//    pucBuffer
//
//  SUMMARY
//   I2C buffer write
//
//  EXPLANATION
//   I2C buffer write
//
//  RETURN
//    SVI G[R[h
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
DWORD CSviControl1::BufferWrite(ULONG ulLen, ULONG ulWriteMode, PUCHAR pucBuffer)
{
	DWORD dwRet;

	// Critical section starts
	CSingleLock obLock(&m_csSync, true);
	m_csSync.Lock();

	// I2C Buffer write
	dwRet = SVI3D1_I2CBufferWrite( ulLen, ulWriteMode, pucBuffer );
	if( dwRet != SVIUSB20_RET_NORMAL ) {
		m_csSync.Unlock();
		return dwRet;
	}

	// Critical section ends
	m_csSync.Unlock();

	return dwRet;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//
//  PARAMETER
//
//  SUMMARY
//    t[yfBOmF
//
//  EXPLANATION
//    t[yfBOmF
//
//  RETURN
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CSviControl1::IsFramePending()
{
	DWORD ret;
	ULONG ulStatus;

	// {Xe[^X擾
	ret = GetStatus2(&ulStatus);

	if(ret == SVIUSB20_RET_NORMAL) {
		if(ulStatus == SVI_STS_FRAMEPENDING) {
			// VOiAbN
//			m_csSync.Unlock();
			return TRUE;
		}
	}

	return FALSE;
}
/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//
//  PARAMETER
//
//  SUMMARY
//    t[yfBOmF
//
//  EXPLANATION
//    t[yfBOmF
//
//  RETURN
//	@GetStatus2̖߂l
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CSviControl1::IsFramePending(DWORD* ret)
{
	ULONG ulStatus;

	// {Xe[^X擾
	*ret = GetStatus2(&ulStatus);

	if(*ret == SVIUSB20_RET_NORMAL) {
		if(ulStatus == SVI_STS_FRAMEPENDING) {
			// VOiAbN
//			m_csSync.Unlock();
			return TRUE;
		}
	}

	return FALSE;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//
//  PARAMETER
//    pStatus
//
//  SUMMARY
//    tXe[^X擾iOIOj
//
//  EXPLANATION
//    tXe[^X擾iOIOj
//
//  RETURN
//    SVI G[R[h
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
DWORD CSviControl1::GetSviStatus(GET_STATUS* pStatus)
{
	// VOibN
	CSingleLock obLock(&m_csSync, true);

	m_csSync.Lock();

	DWORD ret;

	ret = GetStatus(pStatus);

	// VOiAbN
	m_csSync.Unlock();

	return ret;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//
//  PARAMETER
//    pulStatus
//
//  SUMMARY
//    {Xe[^X擾iOIOj
//
//  EXPLANATION
//    {Xe[^X擾iOIOj
//
//  RETURN
//    SVI G[R[h
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
DWORD CSviControl1::GetBaseStatus(ULONG* pulStatus)
{
	// VOibN
	CSingleLock obLock(&m_csSync, true);

	m_csSync.Lock();

	DWORD ret;

	ret = GetStatus2(pulStatus);

	// VOiAbN
	m_csSync.Unlock();

	return ret;
}


/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//
//  PARAMETER
//    pStatus
//
//  SUMMARY
//    tXe[^X擾
//
//  EXPLANATION
//    tXe[^X擾
//
//  RETURN
//    SVI G[R[h
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
DWORD CSviControl1::GetStatus(GET_STATUS* pStatus)
{
	DWORD		ret;

	// Xe[^X擾
	ret = SVI3D1_GetStatus(pStatus);

	if(ret != SVIUSB20_RET_NORMAL) {
		CString csMsg;
		csMsg.Format("SVIUSB20_GetStatus Error return[0x%08X]", ret);
		TRACE(csMsg);
	}

	// VOiAbN
//	m_csSync.Unlock();

	return ret;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//
//  PARAMETER
//    pulStatus
//
//  SUMMARY
//    Xe[^X擾
//
//  EXPLANATION
//    Xe[^X擾
//
//  RETURN
//    SVI G[R[h
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
DWORD CSviControl1::GetStatus2(ULONG* pulStatus)
{
	DWORD		ret;

	// Xe[^X擾
	ret = SVI3D1_GetStatus2(pulStatus);

	if(ret != SVIUSB20_RET_NORMAL) {
		CString csMsg;
		csMsg.Format("SVIUSB20_GetStatus2 Error return[0x%08X]", ret);
		TRACE(csMsg);
	}

	return ret;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//
//  PARAMETER
//
//  SUMMARY
//    oXZbgs
//
//  EXPLANATION
//    oXZbgs
//
//  RETURN
//    SVI G[R[h
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
DWORD CSviControl1::BusReset()
{
	// VOibN
	CSingleLock obLock(&m_csSync, true);

	m_csSync.Lock();

	DWORD		ret;

	// oXZbg
	ret = DevErrorBusReset();

	// VOiAbN
	m_csSync.Unlock();

	return ret;
}


/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//
//  PARAMETER
//
//  SUMMARY
//    foCXG[ifoCXN[Yj
//
//  EXPLANATION
//    foCXG[ifoCXN[Yj
//
//  RETURN
//    SVI G[R[h
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
DWORD CSviControl1::DevErrorClose()
{
	DWORD ret;

	// oXZbg
	ret = SVI3D1_Close(SVIUSB20_APP_WHO_REC);
	if(ret != SVIUSB20_RET_NORMAL) {
		CString csMsg;
		csMsg.Format("SVIUSB20_Close Error return[0x%08X]\n", ret);
		TRACE(csMsg);
	}
	else {
		m_bDevOpen = FALSE;
	}

	return ret;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//
//  PARAMETER
//
//  SUMMARY
//    foCXG[ioXZbgsj
//
//  EXPLANATION
//    foCXG[ioXZbgsj
//
//  RETURN
//    SVI G[R[h
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
DWORD CSviControl1::DevErrorBusReset()
{
	DWORD ret;

	// oXZbg
	ret = SVI3D1_BusReset();
	if(ret != SVIUSB20_RET_NORMAL) {
		CString csMsg;
		csMsg.Format("SVIUSB20_BusReset Error return[0x%08X]\n", ret);
		TRACE(csMsg);
	}

	return ret;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//	  SetMonTimeout
//
//  PARAMETER
//    MonTimeout : ^CAEglibj@0̏ꍇ͖
//
//  SUMMARY
//    j^O^CAEglݒ
//
//  EXPLANATION
//    j^O^CAEglݒ
//
//  RETURN
//    Ȃ
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
void CSviControl1::SetMonTimeout(int MonTimeout)
{
	m_MonTimeout = MonTimeout;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//	  StopMonTimeoutWait
//
//  PARAMETER
//    Ȃ
//
//  SUMMARY
//    j^O^CAEg҂
//
//  EXPLANATION
//    j^O^CAEg҂
//
//  RETURN
//    Ȃ
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
void CSviControl1::StopMonTimeoutWait()
{
	m_StopMonTimeoutWait = FALSE;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//	  StopMonTimeoutWait
//
//  PARAMETER
//    Ȃ
//
//  SUMMARY
//    j^O^CAEg҂x~
//
//  EXPLANATION
//    j^O^CAEg҂x~
//
//  RETURN
//    Ȃ
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
void CSviControl1::SleepMonTimeoutWait()
{
	m_SleepMonTimeoutWait = TRUE;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    GetCurMonHeader
//
//  PARAMETER
//    MonHeader	j^Owb_[i[p|C^
//
//  SUMMARY
//    ݂̃j^Owb_[擾
//
//  EXPLANATION
//    ݂̃j^Owb_[擾
//
//  RETURN
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
void CSviControl1::GetCurMonHeader(MON_HEADER *MonHeader)
{
	*MonHeader = m_monHeader;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    SetBoardNo
//
//  PARAMETER
//    iBoardNo	SVI-03{[hԍ
//
//  SUMMARY
//    gpSVI-03{[hԍRɐݒ肷
//
//  EXPLANATION
//    gpSVI-03{[hԍRɐݒ肷
//
//  RETURN
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
void CSviControl1::SetBoardNo(int iBoardNo)
{
	m_BoardNo = iBoardNo;
}

void CSviControl1::SetBoardExist(bool bExist)
{
	m_bExist = bExist;
}

bool CSviControl1::isExist(void)
{
	return m_bExist;
}
