/*FILE------------------------------------------------------------------------*/
//
//  SVIControl1.h
//
//  SUMMARY
//    SVI I2C control core class header
//
//  WRITER
//    Net Vision
//
//  HISTORY
//    2013/10/xx New creation
//
/*FILE------------------------------------------------------------------------*/
#ifndef _SVI_CONTROL1_H	// SVI Control Class Header
#define _SVI_CONTROL1_H

#include <afxmt.h>

#include "SVI3Ddef.h"
#include "SVI3D1.h"
#include "Comm.h"
#include "FrameData.h"

/*CLASS-----------------------------------------------------------------------*/
//  NAME
//    CSviControl
//
//  SUMMARY
//    SVI I2C Control core class
//
//  EXPLANATION
//    SVI I2C Rg[{NX
//
//  REMARKS
//        NONE
//
/*CLASS-----------------------------------------------------------------------*/
class CSviControl1
{
public:
	// RXgN^
	CSviControl1();

	// fXgN^
	virtual ~CSviControl1();

public:	// SVIANZX֐
	int m_BoardNo;
	void SetBoardNo(int iBoardNo);
	void GetCurMonHeader(MON_HEADER *MonHeader);
	void SleepMonTimeoutWait();
	void StopMonTimeoutWait();
	void SetMonTimeout(int MonTimeout);
	// SVI{[hI[v
	DWORD SviOpen();

	// SVI{[hN[Y
	DWORD SviClose();

	// JXe[^XZbg
	DWORD SetStatus(
					ULONG ulParamBitFlag	= 0,	// [IN] wORZqgp
					ULONG ulVsyncFlag		= 0,	// [IN] VSYNCfAT[gtO(0:fAT[g҂A1@:@fAT[g҂Ȃ )
					ULONG ulCamPower		= 0,	// [IN] JdXCb`i0:OFFA1:ONj
					ULONG ulI2CSpeed		= 0,	// [IN] I2CXs[hi0:400KbpsA1:200KbpsA2:100Kbpsj
					ULONG ulMonMode			= 0,	// [IN] j^O[hi0:DoubleA1:Ringj
					ULONG ulPixelInfo		= 0 );	// [IN] 摜ʒm	bit0-1:F(1or2or3)Abit2:1F̃rbg(0:8bit,1:16bit)

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    IsOpen
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    SVI{[hI[vmF
	//
	//  EXPLANATION
	//    SVI{[hI[vmF
	//
	//  RETURN
	//    TRUE:I[v  FALSE:N[Y
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	BOOL IsOpen() { return m_bDevOpen; };

	/*MFUNC-----------------------------------------------------------------------*/
	//
	//  NAME
	//    IsClose
	//
	//  PARAMETER
	//
	//  SUMMARY
	//    SVI{[hN[YmF
	//
	//  EXPLANATION
	//    SVI{[hN[YmF
	//
	//  RETURN
	//    TRUE:N[Y  FALSE:I[v
	//
	//  REMARKS
	//
	/*MFUNC-----------------------------------------------------------------------*/
	BOOL IsClose() { return !m_bDevOpen; };

	// SVICjVCY
	DWORD Initialize();

	// j^OJn
	DWORD MonStart(
					ULONG ulCutout_x,	// [IN] ؂JnXʒu
					ULONG ulCutout_y,	// [IN] ؂JnYʒu
					ULONG ulCutout_w,	// [IN] ؂艡
					ULONG ulCutout_h); 	// [IN] ؂c

	// j^O~
	DWORD MonStop();

	// j^Of[^擾
	BOOL MonGetData(CFrameData* pFrame, int nPicType);

	// j^Ot[擾
	DWORD MonGetHeader(CFrameData* pFrame);

	// j^Ot[擾
	DWORD MonGetFrame(CFrameData* pFrame, int nPicType);

	// t[yfBOmF
	BOOL IsFramePending();

	// t[yfBOmFiGetStatus̖߂lԋpŁj
	BOOL IsFramePending(DWORD* ret);

	// I2CubNM
	DWORD WriteBlock(DWORD dwWriteMode, DWORD dwSlaveAdr, DWORD dwSendCnt, PBYTE lpSendBuf);

	// I2CubNM
	DWORD ReadBlock(DWORD dwReadMode, DWORD dwSlaveAdr, DWORD dwRcvCnt, PBYTE lpRcvBuf);

	// I2C buffer write
	DWORD BufferWrite(ULONG ulLen, ULONG ulWriteMode, PUCHAR pucBuffer);

	// oXZbgs
	DWORD BusReset();

	// tXe[^X擾iOIOj
	DWORD GetSviStatus(GET_STATUS* pStatus);

	// {Xe[^X擾iOIOj
	DWORD GetBaseStatus(ULONG* pulStatus);

private: // G[
	// foCXG[
	DWORD DevErrorClose();

	// foCXG[ioXZbgsj
	DWORD DevErrorBusReset();

	MON_HEADER m_monHeader;
	int m_SleepMonTimeoutWait;
	int m_StopMonTimeoutWait;
	int m_MonTimeout;
	// tXe[^X擾
	DWORD GetStatus(GET_STATUS* pStatus);

	// {Xe[^X擾
	DWORD GetStatus2(ULONG* pulStatus);

	//
	CCriticalSection m_csSync;			// NeBJ ZNV

	//
	BOOL m_bDevOpen;					// foCXI[vtO
public:
	void SetBoardExist(bool bExist);
	bool isExist(void);
	bool m_bExist;
};

#endif // _SVI_CONTROL1_H End
